#ifndef GUARD_2e2afc8df6107683d574a8d96d5249f4
#define GUARD_2e2afc8df6107683d574a8d96d5249f4

#define USING_DUNE_PYTHON 1
#include <config.h>
#include <dune/alugrid/dgf.hh>
#include <dune/alugrid/grid.hh>
#include <dune/fem/gridpart/adaptiveleafgridpart.hh>
#include <dune/fempy/py/gridview.hh>
#include <dune/python/grid/gridview.hh>
#include <dune/python/grid/hierarchical.hh>
#include <dune/fem/function/localfunction/bindable.hh>
#include <dune/fem/common/intersectionside.hh>
#include <dune/python/pybind11/pybind11.h>
#include <dune/python/pybind11/extensions.h>
#include <dune/fempy/py/grid/gridpart.hh>
#include <dune/common/exceptions.hh>
#include <dune/fempy/py/ufllocalfunction.hh>

namespace UFLLocalFunctions_2e2afc8df6107683d574a8d96d5249f4
{

  // UFLLocalFunction
// ----------------

template< class GridPart >
struct UFLLocalFunction
  : public Dune::Fem::BindableGridFunctionWithSpace<GridPart,Dune::Dim<1>>
{
  typedef GridPart GridPartType;
  typedef typename GridPartType::GridViewType GridView;
  typedef typename GridView::ctype ctype;
  typedef Dune::Fem::BindableGridFunctionWithSpace<GridPart,Dune::Dim<1>> BaseType;
  typedef Dune::Fem::GridFunctionSpace<GridPartType,Dune::Dim<1>> FunctionSpaceType;
  typedef typename GridPartType::template Codim< 0 >::EntityType EntityType;
  typedef typename GridPartType::IntersectionType IntersectionType;
  typedef typename EntityType::Geometry Geometry;
  typedef typename Geometry::GlobalCoordinate GlobalCoordinateType;
  typedef Dune::Fem::IntersectionSide Side;
  typedef double Conepsilon;
  typedef std::tuple< std::shared_ptr< Conepsilon > > ConstantTupleType;
  template< std::size_t i >
  using ConstantsRangeType = typename std::tuple_element_t< i, ConstantTupleType >::element_type;
  typedef std::tuple<> CoefficientTupleType;
  static constexpr bool gridPartValid = true;
  template< std::size_t i >
  using CoefficientType = std::tuple_element_t< i, CoefficientTupleType >;
  template< std::size_t i >
  using ConstantType = typename std::tuple_element_t< i, ConstantTupleType >::element_type;
  using BaseType::entity;
  using BaseType::geometry;

  UFLLocalFunction ( const GridPartType &gridPart, const std::string &name, int order, const Dune::Fem::ParameterReader &parameter = Dune::Fem::Parameter::container() )
    : BaseType(gridPart,name,order)
  {
    std::get< 0 >( constants_ ) = std::make_shared< Conepsilon >( (Conepsilon(0)) );
  }

  void bind ( const IntersectionType &intersection, Side side )
  {
    BaseType::bind(intersection, side);
  }

  void bind ( const EntityType &entity )
  {
    BaseType::bind(entity);
  }

  void unbind ()
  {
    BaseType::unbind();
  }

  template< class Point >
  void evaluate ( const Point &x, typename FunctionSpaceType::RangeType &result ) const
  {
    using std::max;
    using std::min;
    using std::sqrt;
    using std::tanh;
    double tmp0 = constant< 0 >();
    GlobalCoordinateType tmp1 = geometry().global( Dune::Fem::coordinate( x ) );
    const auto tmp2 = tmp1[ 1 ] * tmp1[ 1 ];
    const auto tmp3 = tmp1[ 0 ] * tmp1[ 0 ];
    const auto tmp4 = tmp3 + tmp2;
    const auto tmp5 = 1e-10 + tmp4;
    const auto tmp6 = std::sqrt( tmp5 );
    const auto tmp7 = -0.4 + tmp6;
    const auto tmp8 = 0.15 + tmp1[ 1 ];
    const auto tmp9 = tmp8 * tmp8;
    const auto tmp10 = 0.15 + tmp1[ 0 ];
    const auto tmp11 = tmp10 * tmp10;
    const auto tmp12 = tmp11 + tmp9;
    const auto tmp13 = 1e-10 + tmp12;
    const auto tmp14 = std::sqrt( tmp13 );
    const auto tmp15 = -0.3 + tmp14;
    const auto tmp16 = -0.15 + tmp1[ 1 ];
    const auto tmp17 = tmp16 * tmp16;
    const auto tmp18 = -0.15 + tmp1[ 0 ];
    const auto tmp19 = tmp18 * tmp18;
    const auto tmp20 = tmp19 + tmp17;
    const auto tmp21 = 1e-10 + tmp20;
    const auto tmp22 = std::sqrt( tmp21 );
    const auto tmp23 = -0.3 + tmp22;
    const auto tmp24 = std::min( tmp23, tmp15 );
    const auto tmp25 = std::max( tmp24, tmp7 );
    const auto tmp26 = 3 * tmp25;
    const auto tmp27 = tmp26 / tmp0;
    const auto tmp28 = std::tanh( tmp27 );
    const auto tmp29 = -1 * tmp28;
    const auto tmp30 = 1 + tmp29;
    const auto tmp31 = 0.5 * tmp30;
    const auto tmp32 = -1 * tmp31;
    const auto tmp33 = 1 + tmp32;
    const auto tmp34 = tmp33 * tmp31;
    result[ 0 ] = tmp34;
  }

  template< class Point >
  void jacobian ( const Point &x, typename FunctionSpaceType::JacobianRangeType &result ) const
  {
    using std::cosh;
    using std::max;
    using std::min;
    using std::pow;
    using std::sqrt;
    using std::tanh;
    double tmp0 = constant< 0 >();
    GlobalCoordinateType tmp1 = geometry().global( Dune::Fem::coordinate( x ) );
    const auto tmp2 = tmp1[ 1 ] * tmp1[ 1 ];
    const auto tmp3 = tmp1[ 0 ] * tmp1[ 0 ];
    const auto tmp4 = tmp3 + tmp2;
    const auto tmp5 = 1e-10 + tmp4;
    const auto tmp6 = std::sqrt( tmp5 );
    const auto tmp7 = -0.4 + tmp6;
    const auto tmp8 = 0.15 + tmp1[ 1 ];
    const auto tmp9 = tmp8 * tmp8;
    const auto tmp10 = 0.15 + tmp1[ 0 ];
    const auto tmp11 = tmp10 * tmp10;
    const auto tmp12 = tmp11 + tmp9;
    const auto tmp13 = 1e-10 + tmp12;
    const auto tmp14 = std::sqrt( tmp13 );
    const auto tmp15 = -0.3 + tmp14;
    const auto tmp16 = -0.15 + tmp1[ 1 ];
    const auto tmp17 = tmp16 * tmp16;
    const auto tmp18 = -0.15 + tmp1[ 0 ];
    const auto tmp19 = tmp18 * tmp18;
    const auto tmp20 = tmp19 + tmp17;
    const auto tmp21 = 1e-10 + tmp20;
    const auto tmp22 = std::sqrt( tmp21 );
    const auto tmp23 = -0.3 + tmp22;
    const auto tmp24 = std::min( tmp23, tmp15 );
    const auto tmp25 = std::max( tmp24, tmp7 );
    const auto tmp26 = 3 * tmp25;
    const auto tmp27 = tmp26 / tmp0;
    const auto tmp28 = 2.0 * tmp27;
    const auto tmp29 = std::cosh( tmp28 );
    const auto tmp30 = 1.0 + tmp29;
    const auto tmp31 = std::cosh( tmp27 );
    const auto tmp32 = 2.0 * tmp31;
    const auto tmp33 = tmp32 / tmp30;
    const auto tmp34 = std::pow( tmp33, 2 );
    const auto tmp35 = 2 * tmp22;
    const auto tmp36 = tmp18 + tmp18;
    const auto tmp37 = tmp36 / tmp35;
    const auto tmp38 = tmp37 * (tmp23 < tmp15 ? 1 : 0.0);
    const auto tmp39 = 2 * tmp14;
    const auto tmp40 = tmp10 + tmp10;
    const auto tmp41 = tmp40 / tmp39;
    const auto tmp42 = -1 * (tmp23 < tmp15 ? 1 : 0.0);
    const auto tmp43 = 1.0 + tmp42;
    const auto tmp44 = tmp43 * tmp41;
    const auto tmp45 = tmp44 + tmp38;
    const auto tmp46 = tmp45 * (tmp24 > tmp7 ? 1 : 0.0);
    const auto tmp47 = 2 * tmp6;
    const auto tmp48 = tmp1[ 0 ] + tmp1[ 0 ];
    const auto tmp49 = tmp48 / tmp47;
    const auto tmp50 = -1 * (tmp24 > tmp7 ? 1 : 0.0);
    const auto tmp51 = 1.0 + tmp50;
    const auto tmp52 = tmp51 * tmp49;
    const auto tmp53 = tmp52 + tmp46;
    const auto tmp54 = 3 * tmp53;
    const auto tmp55 = tmp54 / tmp0;
    const auto tmp56 = tmp55 * tmp34;
    const auto tmp57 = -1 * tmp56;
    const auto tmp58 = 0.5 * tmp57;
    const auto tmp59 = std::tanh( tmp27 );
    const auto tmp60 = -1 * tmp59;
    const auto tmp61 = 1 + tmp60;
    const auto tmp62 = 0.5 * tmp61;
    const auto tmp63 = -1 * tmp62;
    const auto tmp64 = 1 + tmp63;
    const auto tmp65 = tmp64 * tmp58;
    const auto tmp66 = -1 * tmp58;
    const auto tmp67 = tmp62 * tmp66;
    const auto tmp68 = tmp67 + tmp65;
    const auto tmp69 = tmp16 + tmp16;
    const auto tmp70 = tmp69 / tmp35;
    const auto tmp71 = tmp70 * (tmp23 < tmp15 ? 1 : 0.0);
    const auto tmp72 = tmp8 + tmp8;
    const auto tmp73 = tmp72 / tmp39;
    const auto tmp74 = tmp43 * tmp73;
    const auto tmp75 = tmp74 + tmp71;
    const auto tmp76 = tmp75 * (tmp24 > tmp7 ? 1 : 0.0);
    const auto tmp77 = tmp1[ 1 ] + tmp1[ 1 ];
    const auto tmp78 = tmp77 / tmp47;
    const auto tmp79 = tmp51 * tmp78;
    const auto tmp80 = tmp79 + tmp76;
    const auto tmp81 = 3 * tmp80;
    const auto tmp82 = tmp81 / tmp0;
    const auto tmp83 = tmp82 * tmp34;
    const auto tmp84 = -1 * tmp83;
    const auto tmp85 = 0.5 * tmp84;
    const auto tmp86 = tmp64 * tmp85;
    const auto tmp87 = -1 * tmp85;
    const auto tmp88 = tmp62 * tmp87;
    const auto tmp89 = tmp88 + tmp86;
    (result[ 0 ])[ 0 ] = tmp68;
    (result[ 0 ])[ 1 ] = tmp89;
  }

  template< class Point >
  void hessian ( const Point &x, typename FunctionSpaceType::HessianRangeType &result ) const
  {
    using std::cosh;
    using std::max;
    using std::min;
    using std::pow;
    using std::sinh;
    using std::sqrt;
    using std::tanh;
    double tmp0 = constant< 0 >();
    GlobalCoordinateType tmp1 = geometry().global( Dune::Fem::coordinate( x ) );
    const auto tmp2 = tmp1[ 1 ] * tmp1[ 1 ];
    const auto tmp3 = tmp1[ 0 ] * tmp1[ 0 ];
    const auto tmp4 = tmp3 + tmp2;
    const auto tmp5 = 1e-10 + tmp4;
    const auto tmp6 = std::sqrt( tmp5 );
    const auto tmp7 = -0.4 + tmp6;
    const auto tmp8 = 0.15 + tmp1[ 1 ];
    const auto tmp9 = tmp8 * tmp8;
    const auto tmp10 = 0.15 + tmp1[ 0 ];
    const auto tmp11 = tmp10 * tmp10;
    const auto tmp12 = tmp11 + tmp9;
    const auto tmp13 = 1e-10 + tmp12;
    const auto tmp14 = std::sqrt( tmp13 );
    const auto tmp15 = -0.3 + tmp14;
    const auto tmp16 = -0.15 + tmp1[ 1 ];
    const auto tmp17 = tmp16 * tmp16;
    const auto tmp18 = -0.15 + tmp1[ 0 ];
    const auto tmp19 = tmp18 * tmp18;
    const auto tmp20 = tmp19 + tmp17;
    const auto tmp21 = 1e-10 + tmp20;
    const auto tmp22 = std::sqrt( tmp21 );
    const auto tmp23 = -0.3 + tmp22;
    const auto tmp24 = std::min( tmp23, tmp15 );
    const auto tmp25 = std::max( tmp24, tmp7 );
    const auto tmp26 = 3 * tmp25;
    const auto tmp27 = tmp26 / tmp0;
    const auto tmp28 = 2.0 * tmp27;
    const auto tmp29 = std::cosh( tmp28 );
    const auto tmp30 = 1.0 + tmp29;
    const auto tmp31 = std::cosh( tmp27 );
    const auto tmp32 = 2.0 * tmp31;
    const auto tmp33 = tmp32 / tmp30;
    const auto tmp34 = std::pow( tmp33, 2 );
    const auto tmp35 = 2 * tmp22;
    const auto tmp36 = tmp18 + tmp18;
    const auto tmp37 = tmp36 / tmp35;
    const auto tmp38 = tmp37 * (tmp23 < tmp15 ? 1 : 0.0);
    const auto tmp39 = 2 * tmp14;
    const auto tmp40 = tmp10 + tmp10;
    const auto tmp41 = tmp40 / tmp39;
    const auto tmp42 = -1 * (tmp23 < tmp15 ? 1 : 0.0);
    const auto tmp43 = 1.0 + tmp42;
    const auto tmp44 = tmp43 * tmp41;
    const auto tmp45 = tmp44 + tmp38;
    const auto tmp46 = tmp45 * (tmp24 > tmp7 ? 1 : 0.0);
    const auto tmp47 = 2 * tmp6;
    const auto tmp48 = tmp1[ 0 ] + tmp1[ 0 ];
    const auto tmp49 = tmp48 / tmp47;
    const auto tmp50 = -1 * (tmp24 > tmp7 ? 1 : 0.0);
    const auto tmp51 = 1.0 + tmp50;
    const auto tmp52 = tmp51 * tmp49;
    const auto tmp53 = tmp52 + tmp46;
    const auto tmp54 = 3 * tmp53;
    const auto tmp55 = tmp54 / tmp0;
    const auto tmp56 = tmp55 * tmp34;
    const auto tmp57 = -1 * tmp56;
    const auto tmp58 = 0.5 * tmp57;
    const auto tmp59 = -1 * tmp58;
    const auto tmp60 = tmp59 * tmp58;
    const auto tmp61 = 2 * tmp37;
    const auto tmp62 = tmp61 * tmp37;
    const auto tmp63 = -1 * tmp62;
    const auto tmp64 = 2 + tmp63;
    const auto tmp65 = tmp64 / tmp35;
    const auto tmp66 = tmp65 * (tmp23 < tmp15 ? 1 : 0.0);
    const auto tmp67 = 2 * tmp41;
    const auto tmp68 = tmp67 * tmp41;
    const auto tmp69 = -1 * tmp68;
    const auto tmp70 = 2 + tmp69;
    const auto tmp71 = tmp70 / tmp39;
    const auto tmp72 = tmp43 * tmp71;
    const auto tmp73 = tmp72 + tmp66;
    const auto tmp74 = tmp73 * (tmp24 > tmp7 ? 1 : 0.0);
    const auto tmp75 = 2 * tmp49;
    const auto tmp76 = tmp75 * tmp49;
    const auto tmp77 = -1 * tmp76;
    const auto tmp78 = 2 + tmp77;
    const auto tmp79 = tmp78 / tmp47;
    const auto tmp80 = tmp51 * tmp79;
    const auto tmp81 = tmp80 + tmp74;
    const auto tmp82 = 3 * tmp81;
    const auto tmp83 = tmp82 / tmp0;
    const auto tmp84 = tmp83 * tmp34;
    const auto tmp85 = std::sinh( tmp27 );
    const auto tmp86 = tmp55 * tmp85;
    const auto tmp87 = 2.0 * tmp86;
    const auto tmp88 = std::sinh( tmp28 );
    const auto tmp89 = 2.0 * tmp55;
    const auto tmp90 = tmp89 * tmp88;
    const auto tmp91 = tmp90 * tmp33;
    const auto tmp92 = -1 * tmp91;
    const auto tmp93 = tmp92 + tmp87;
    const auto tmp94 = tmp93 / tmp30;
    const auto tmp95 = 2 * tmp94;
    const auto tmp96 = tmp95 * tmp33;
    const auto tmp97 = tmp96 * tmp55;
    const auto tmp98 = tmp97 + tmp84;
    const auto tmp99 = -1 * tmp98;
    const auto tmp100 = 0.5 * tmp99;
    const auto tmp101 = -1 * tmp100;
    const auto tmp102 = std::tanh( tmp27 );
    const auto tmp103 = -1 * tmp102;
    const auto tmp104 = 1 + tmp103;
    const auto tmp105 = 0.5 * tmp104;
    const auto tmp106 = tmp105 * tmp101;
    const auto tmp107 = tmp106 + tmp60;
    const auto tmp108 = -1 * tmp105;
    const auto tmp109 = 1 + tmp108;
    const auto tmp110 = tmp109 * tmp100;
    const auto tmp111 = tmp110 + tmp60;
    const auto tmp112 = tmp111 + tmp107;
    const auto tmp113 = tmp16 + tmp16;
    const auto tmp114 = tmp113 / tmp35;
    const auto tmp115 = tmp114 * (tmp23 < tmp15 ? 1 : 0.0);
    const auto tmp116 = tmp8 + tmp8;
    const auto tmp117 = tmp116 / tmp39;
    const auto tmp118 = tmp43 * tmp117;
    const auto tmp119 = tmp118 + tmp115;
    const auto tmp120 = tmp119 * (tmp24 > tmp7 ? 1 : 0.0);
    const auto tmp121 = tmp1[ 1 ] + tmp1[ 1 ];
    const auto tmp122 = tmp121 / tmp47;
    const auto tmp123 = tmp51 * tmp122;
    const auto tmp124 = tmp123 + tmp120;
    const auto tmp125 = 3 * tmp124;
    const auto tmp126 = tmp125 / tmp0;
    const auto tmp127 = tmp126 * tmp34;
    const auto tmp128 = -1 * tmp127;
    const auto tmp129 = 0.5 * tmp128;
    const auto tmp130 = tmp59 * tmp129;
    const auto tmp131 = 2 * tmp114;
    const auto tmp132 = tmp131 * tmp37;
    const auto tmp133 = -1 * tmp132;
    const auto tmp134 = tmp133 / tmp35;
    const auto tmp135 = tmp134 * (tmp23 < tmp15 ? 1 : 0.0);
    const auto tmp136 = 2 * tmp117;
    const auto tmp137 = tmp136 * tmp41;
    const auto tmp138 = -1 * tmp137;
    const auto tmp139 = tmp138 / tmp39;
    const auto tmp140 = tmp43 * tmp139;
    const auto tmp141 = tmp140 + tmp135;
    const auto tmp142 = tmp141 * (tmp24 > tmp7 ? 1 : 0.0);
    const auto tmp143 = 2 * tmp122;
    const auto tmp144 = tmp143 * tmp49;
    const auto tmp145 = -1 * tmp144;
    const auto tmp146 = tmp145 / tmp47;
    const auto tmp147 = tmp51 * tmp146;
    const auto tmp148 = tmp147 + tmp142;
    const auto tmp149 = 3 * tmp148;
    const auto tmp150 = tmp149 / tmp0;
    const auto tmp151 = tmp150 * tmp34;
    const auto tmp152 = tmp126 * tmp85;
    const auto tmp153 = 2.0 * tmp152;
    const auto tmp154 = 2.0 * tmp126;
    const auto tmp155 = tmp154 * tmp88;
    const auto tmp156 = tmp155 * tmp33;
    const auto tmp157 = -1 * tmp156;
    const auto tmp158 = tmp157 + tmp153;
    const auto tmp159 = tmp158 / tmp30;
    const auto tmp160 = 2 * tmp159;
    const auto tmp161 = tmp160 * tmp33;
    const auto tmp162 = tmp161 * tmp55;
    const auto tmp163 = tmp162 + tmp151;
    const auto tmp164 = -1 * tmp163;
    const auto tmp165 = 0.5 * tmp164;
    const auto tmp166 = -1 * tmp165;
    const auto tmp167 = tmp105 * tmp166;
    const auto tmp168 = tmp167 + tmp130;
    const auto tmp169 = -1 * tmp129;
    const auto tmp170 = tmp169 * tmp58;
    const auto tmp171 = tmp109 * tmp165;
    const auto tmp172 = tmp171 + tmp170;
    const auto tmp173 = tmp172 + tmp168;
    const auto tmp174 = tmp61 * tmp114;
    const auto tmp175 = -1 * tmp174;
    const auto tmp176 = tmp175 / tmp35;
    const auto tmp177 = tmp176 * (tmp23 < tmp15 ? 1 : 0.0);
    const auto tmp178 = tmp67 * tmp117;
    const auto tmp179 = -1 * tmp178;
    const auto tmp180 = tmp179 / tmp39;
    const auto tmp181 = tmp43 * tmp180;
    const auto tmp182 = tmp181 + tmp177;
    const auto tmp183 = tmp182 * (tmp24 > tmp7 ? 1 : 0.0);
    const auto tmp184 = tmp75 * tmp122;
    const auto tmp185 = -1 * tmp184;
    const auto tmp186 = tmp185 / tmp47;
    const auto tmp187 = tmp51 * tmp186;
    const auto tmp188 = tmp187 + tmp183;
    const auto tmp189 = 3 * tmp188;
    const auto tmp190 = tmp189 / tmp0;
    const auto tmp191 = tmp190 * tmp34;
    const auto tmp192 = tmp96 * tmp126;
    const auto tmp193 = tmp192 + tmp191;
    const auto tmp194 = -1 * tmp193;
    const auto tmp195 = 0.5 * tmp194;
    const auto tmp196 = tmp109 * tmp195;
    const auto tmp197 = tmp196 + tmp130;
    const auto tmp198 = -1 * tmp195;
    const auto tmp199 = tmp105 * tmp198;
    const auto tmp200 = tmp199 + tmp170;
    const auto tmp201 = tmp200 + tmp197;
    const auto tmp202 = tmp169 * tmp129;
    const auto tmp203 = tmp131 * tmp114;
    const auto tmp204 = -1 * tmp203;
    const auto tmp205 = 2 + tmp204;
    const auto tmp206 = tmp205 / tmp35;
    const auto tmp207 = tmp206 * (tmp23 < tmp15 ? 1 : 0.0);
    const auto tmp208 = tmp136 * tmp117;
    const auto tmp209 = -1 * tmp208;
    const auto tmp210 = 2 + tmp209;
    const auto tmp211 = tmp210 / tmp39;
    const auto tmp212 = tmp43 * tmp211;
    const auto tmp213 = tmp212 + tmp207;
    const auto tmp214 = tmp213 * (tmp24 > tmp7 ? 1 : 0.0);
    const auto tmp215 = tmp143 * tmp122;
    const auto tmp216 = -1 * tmp215;
    const auto tmp217 = 2 + tmp216;
    const auto tmp218 = tmp217 / tmp47;
    const auto tmp219 = tmp51 * tmp218;
    const auto tmp220 = tmp219 + tmp214;
    const auto tmp221 = 3 * tmp220;
    const auto tmp222 = tmp221 / tmp0;
    const auto tmp223 = tmp222 * tmp34;
    const auto tmp224 = tmp161 * tmp126;
    const auto tmp225 = tmp224 + tmp223;
    const auto tmp226 = -1 * tmp225;
    const auto tmp227 = 0.5 * tmp226;
    const auto tmp228 = -1 * tmp227;
    const auto tmp229 = tmp105 * tmp228;
    const auto tmp230 = tmp229 + tmp202;
    const auto tmp231 = tmp109 * tmp227;
    const auto tmp232 = tmp231 + tmp202;
    const auto tmp233 = tmp232 + tmp230;
    ((result[ 0 ])[ 0 ])[ 0 ] = tmp112;
    ((result[ 0 ])[ 0 ])[ 1 ] = tmp173;
    ((result[ 0 ])[ 1 ])[ 0 ] = tmp201;
    ((result[ 0 ])[ 1 ])[ 1 ] = tmp233;
  }

  template< std::size_t i >
  const ConstantType< i > &constant () const
  {
    return *std::get< i >( constants_ );
  }

  template< std::size_t i >
  ConstantType< i > &constant ()
  {
    return *std::get< i >( constants_ );
  }

  const Conepsilon &conepsilon () const
  {
    return *std::get< 0 >( constants_ );
  }

  Conepsilon &conepsilon ()
  {
    return *std::get< 0 >( constants_ );
  }
  ConstantTupleType constants_;
  std::tuple<  > coefficients_;
};

} // namespace UFLLocalFunctions_2e2afc8df6107683d574a8d96d5249f4

PYBIND11_MODULE( localfunction_2e2afc8df6107683d574a8d96d5249f4_af122c1df944c95cd395ec0f91d0f970, module )
{
  typedef UFLLocalFunctions_2e2afc8df6107683d574a8d96d5249f4::UFLLocalFunction< typename Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > > > LocalFunctionType;
  if constexpr( LocalFunctionType::gridPartValid )
  {
      auto cls = Dune::Python::insertClass<LocalFunctionType>(module,"UFLLocalFunction",Dune::Python::GenerateTypeName("UFLLocalFunctions_2e2afc8df6107683d574a8d96d5249f4::UFLLocalFunction< typename Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > > >"), Dune::Python::IncludeFiles({"python/dune/generated/localfunction_2e2afc8df6107683d574a8d96d5249f4_af122c1df944c95cd395ec0f91d0f970.cc"})).first;
      Dune::FemPy::registerUFLLocalFunction( module, cls );
      cls.def( pybind11::init( [] ( pybind11::object gridView, const std::string &name, int order ) {return new LocalFunctionType( Dune::FemPy::gridPart<Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > >>(gridView),name,order); } ), pybind11::keep_alive< 1, 2 >() );
      cls.def_property( "epsilon", [] ( LocalFunctionType &self ) -> UFLLocalFunctions_2e2afc8df6107683d574a8d96d5249f4::UFLLocalFunction< typename Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > > >::Conepsilon { return self.conepsilon(); }, [] ( LocalFunctionType &self, const UFLLocalFunctions_2e2afc8df6107683d574a8d96d5249f4::UFLLocalFunction< typename Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > > >::Conepsilon &v ) { self.conepsilon() = v; } );
      cls.def_property_readonly( "virtualized", [] ( LocalFunctionType& ) -> bool { return true;});
  }
}

#endif
