#ifndef GUARD_5591a2c803b9658084d8f11d44bf3ae1
#define GUARD_5591a2c803b9658084d8f11d44bf3ae1

#define USING_DUNE_PYTHON 1
#include <config.h>
#include <dune/alugrid/dgf.hh>
#include <dune/alugrid/grid.hh>
#include <dune/fem/gridpart/adaptiveleafgridpart.hh>
#include <dune/fem/gridpart/filter/simple.hh>
#include <dune/fem/gridpart/filteredgridpart.hh>
#include <dune/fempy/py/gridview.hh>
#include <dune/python/grid/gridview.hh>
#include <dune/python/grid/hierarchical.hh>
#include <dune/fem/function/localfunction/bindable.hh>
#include <dune/fem/common/intersectionside.hh>
#include <dune/python/pybind11/pybind11.h>
#include <dune/python/pybind11/extensions.h>
#include <dune/fempy/py/grid/gridpart.hh>
#include <dune/common/exceptions.hh>
#include <dune/fempy/function/virtualizedgridfunction.hh>
#include <dune/fempy/py/ufllocalfunction.hh>

namespace UFLLocalFunctions_5591a2c803b9658084d8f11d44bf3ae1
{

  // UFLLocalFunction
// ----------------

template< class GridPart, class Coeffbndproj >
struct UFLLocalFunction
  : public Dune::Fem::BindableGridFunctionWithSpace<GridPart,Dune::Dim<1>>
{
  typedef GridPart GridPartType;
  typedef typename GridPartType::GridViewType GridView;
  typedef typename GridView::ctype ctype;
  typedef Dune::Fem::BindableGridFunctionWithSpace<GridPart,Dune::Dim<1>> BaseType;
  typedef Dune::Fem::GridFunctionSpace<GridPartType,Dune::Dim<1>> FunctionSpaceType;
  typedef typename GridPartType::template Codim< 0 >::EntityType EntityType;
  typedef typename GridPartType::IntersectionType IntersectionType;
  typedef typename EntityType::Geometry Geometry;
  typedef typename Geometry::GlobalCoordinate GlobalCoordinateType;
  typedef Dune::Fem::IntersectionSide Side;
  typedef double Conepsilon;
  typedef std::tuple< std::shared_ptr< Conepsilon > > ConstantTupleType;
  template< std::size_t i >
  using ConstantsRangeType = typename std::tuple_element_t< i, ConstantTupleType >::element_type;
  typedef std::tuple< Dune::Fem::GridFunctionSpace< GridPartType, Dune::FieldVector< double, 2 > > > CoefficientFunctionSpaceTupleType;
  typedef std::tuple< Coeffbndproj > CoefficientTupleType;
  template< std::size_t i >
  using CoefficientFunctionSpaceType = std::tuple_element_t< i, CoefficientFunctionSpaceTupleType >;
  template< std::size_t i >
  using CoefficientRangeType = typename CoefficientFunctionSpaceType< i >::RangeType;
  template< std::size_t i >
  using CoefficientJacobianRangeType = typename CoefficientFunctionSpaceType< i >::JacobianRangeType;
  static constexpr bool gridPartValid = Dune::Fem::checkGridPartValid<GridPartType,Dune::Fem::ConstLocalFunction<Coeffbndproj>>();
  template< std::size_t i >
  using CoefficientType = std::tuple_element_t< i, CoefficientTupleType >;
  template< std::size_t i >
  using ConstantType = typename std::tuple_element_t< i, ConstantTupleType >::element_type;
  using BaseType::entity;
  using BaseType::geometry;

  UFLLocalFunction ( const GridPartType &gridPart, const std::string &name, int order, const Coeffbndproj &coeffbndproj, const Dune::Fem::ParameterReader &parameter = Dune::Fem::Parameter::container() )
    : BaseType(gridPart,name,order),
      coefficients_( Dune::Fem::ConstLocalFunction< Coeffbndproj >( coeffbndproj ) )
  {
    std::get< 0 >( constants_ ) = std::make_shared< Conepsilon >( (Conepsilon(0)) );
  }

  void bind ( const IntersectionType &intersection, Side side )
  {
    BaseType::bind(intersection, side);
    std::get< 0 >( coefficients_ ).bind( this->entity() );
  }

  void bind ( const EntityType &entity )
  {
    BaseType::bind(entity);
    std::get< 0 >( coefficients_ ).bind( this->entity() );
  }

  void unbind ()
  {
    BaseType::unbind();
    std::get< 0 >( coefficients_ ).unbind();
  }

  template< class Point >
  void evaluate ( const Point &x, typename FunctionSpaceType::RangeType &result ) const
  {
    using std::min;
    using std::sqrt;
    using std::tanh;
    double tmp0 = constant< 0 >();
    typename CoefficientFunctionSpaceType< 0 >::RangeType tmp1 = evaluateCoefficient< 0 >( x );
    const auto tmp2 = -1 * tmp1[ 0 ];
    const auto tmp3 = -0.4 + tmp2;
    const auto tmp4 = tmp1[ 1 ] * tmp1[ 1 ];
    const auto tmp5 = tmp1[ 0 ] * tmp1[ 0 ];
    const auto tmp6 = tmp5 + tmp4;
    const auto tmp7 = 1e-10 + tmp6;
    const auto tmp8 = std::sqrt( tmp7 );
    const auto tmp9 = -1.4 + tmp8;
    const auto tmp10 = std::min( tmp9, tmp3 );
    const auto tmp11 = 3 * tmp10;
    const auto tmp12 = tmp11 / tmp0;
    const auto tmp13 = std::tanh( tmp12 );
    const auto tmp14 = -1 * tmp13;
    const auto tmp15 = 1 + tmp14;
    const auto tmp16 = 0.5 * tmp15;
    const auto tmp17 = -1 * tmp16;
    const auto tmp18 = 1 + tmp17;
    const auto tmp19 = tmp18 * tmp16;
    result[ 0 ] = tmp19;
  }

  template< class Point >
  void jacobian ( const Point &x, typename FunctionSpaceType::JacobianRangeType &result ) const
  {
    using std::cosh;
    using std::min;
    using std::pow;
    using std::sqrt;
    using std::tanh;
    double tmp0 = constant< 0 >();
    typename CoefficientFunctionSpaceType< 0 >::RangeType tmp1 = evaluateCoefficient< 0 >( x );
    const auto tmp2 = -1 * tmp1[ 0 ];
    const auto tmp3 = -0.4 + tmp2;
    const auto tmp4 = tmp1[ 1 ] * tmp1[ 1 ];
    const auto tmp5 = tmp1[ 0 ] * tmp1[ 0 ];
    const auto tmp6 = tmp5 + tmp4;
    const auto tmp7 = 1e-10 + tmp6;
    const auto tmp8 = std::sqrt( tmp7 );
    const auto tmp9 = -1.4 + tmp8;
    const auto tmp10 = std::min( tmp9, tmp3 );
    const auto tmp11 = 3 * tmp10;
    const auto tmp12 = tmp11 / tmp0;
    const auto tmp13 = 2.0 * tmp12;
    const auto tmp14 = std::cosh( tmp13 );
    const auto tmp15 = 1.0 + tmp14;
    const auto tmp16 = std::cosh( tmp12 );
    const auto tmp17 = 2.0 * tmp16;
    const auto tmp18 = tmp17 / tmp15;
    const auto tmp19 = std::pow( tmp18, 2 );
    const auto tmp20 = 2 * tmp8;
    typename CoefficientFunctionSpaceType< 0 >::JacobianRangeType tmp21 = jacobianCoefficient< 0 >( x );
    const auto tmp22 = tmp1[ 1 ] * (tmp21[ 1 ])[ 0 ];
    const auto tmp23 = tmp22 + tmp22;
    const auto tmp24 = tmp1[ 0 ] * (tmp21[ 0 ])[ 0 ];
    const auto tmp25 = tmp24 + tmp24;
    const auto tmp26 = tmp25 + tmp23;
    const auto tmp27 = tmp26 / tmp20;
    const auto tmp28 = tmp27 * (tmp9 < tmp3 ? 1 : 0.0);
    const auto tmp29 = -1 * (tmp21[ 0 ])[ 0 ];
    const auto tmp30 = -1 * (tmp9 < tmp3 ? 1 : 0.0);
    const auto tmp31 = 1.0 + tmp30;
    const auto tmp32 = tmp31 * tmp29;
    const auto tmp33 = tmp32 + tmp28;
    const auto tmp34 = 3 * tmp33;
    const auto tmp35 = tmp34 / tmp0;
    const auto tmp36 = tmp35 * tmp19;
    const auto tmp37 = -1 * tmp36;
    const auto tmp38 = 0.5 * tmp37;
    const auto tmp39 = std::tanh( tmp12 );
    const auto tmp40 = -1 * tmp39;
    const auto tmp41 = 1 + tmp40;
    const auto tmp42 = 0.5 * tmp41;
    const auto tmp43 = -1 * tmp42;
    const auto tmp44 = 1 + tmp43;
    const auto tmp45 = tmp44 * tmp38;
    const auto tmp46 = -1 * tmp38;
    const auto tmp47 = tmp42 * tmp46;
    const auto tmp48 = tmp47 + tmp45;
    const auto tmp49 = tmp1[ 1 ] * (tmp21[ 1 ])[ 1 ];
    const auto tmp50 = tmp49 + tmp49;
    const auto tmp51 = tmp1[ 0 ] * (tmp21[ 0 ])[ 1 ];
    const auto tmp52 = tmp51 + tmp51;
    const auto tmp53 = tmp52 + tmp50;
    const auto tmp54 = tmp53 / tmp20;
    const auto tmp55 = tmp54 * (tmp9 < tmp3 ? 1 : 0.0);
    const auto tmp56 = -1 * (tmp21[ 0 ])[ 1 ];
    const auto tmp57 = tmp31 * tmp56;
    const auto tmp58 = tmp57 + tmp55;
    const auto tmp59 = 3 * tmp58;
    const auto tmp60 = tmp59 / tmp0;
    const auto tmp61 = tmp60 * tmp19;
    const auto tmp62 = -1 * tmp61;
    const auto tmp63 = 0.5 * tmp62;
    const auto tmp64 = tmp44 * tmp63;
    const auto tmp65 = -1 * tmp63;
    const auto tmp66 = tmp42 * tmp65;
    const auto tmp67 = tmp66 + tmp64;
    (result[ 0 ])[ 0 ] = tmp48;
    (result[ 0 ])[ 1 ] = tmp67;
  }

  template< class Point >
  void hessian ( const Point &x, typename FunctionSpaceType::HessianRangeType &result ) const
  {
    using std::cosh;
    using std::min;
    using std::pow;
    using std::sinh;
    using std::sqrt;
    using std::tanh;
    double tmp0 = constant< 0 >();
    typename CoefficientFunctionSpaceType< 0 >::RangeType tmp1 = evaluateCoefficient< 0 >( x );
    const auto tmp2 = -1 * tmp1[ 0 ];
    const auto tmp3 = -0.4 + tmp2;
    const auto tmp4 = tmp1[ 1 ] * tmp1[ 1 ];
    const auto tmp5 = tmp1[ 0 ] * tmp1[ 0 ];
    const auto tmp6 = tmp5 + tmp4;
    const auto tmp7 = 1e-10 + tmp6;
    const auto tmp8 = std::sqrt( tmp7 );
    const auto tmp9 = -1.4 + tmp8;
    const auto tmp10 = std::min( tmp9, tmp3 );
    const auto tmp11 = 3 * tmp10;
    const auto tmp12 = tmp11 / tmp0;
    const auto tmp13 = 2.0 * tmp12;
    const auto tmp14 = std::cosh( tmp13 );
    const auto tmp15 = 1.0 + tmp14;
    const auto tmp16 = std::cosh( tmp12 );
    const auto tmp17 = 2.0 * tmp16;
    const auto tmp18 = tmp17 / tmp15;
    const auto tmp19 = std::pow( tmp18, 2 );
    const auto tmp20 = 2 * tmp8;
    typename CoefficientFunctionSpaceType< 0 >::JacobianRangeType tmp21 = jacobianCoefficient< 0 >( x );
    const auto tmp22 = tmp1[ 1 ] * (tmp21[ 1 ])[ 0 ];
    const auto tmp23 = tmp22 + tmp22;
    const auto tmp24 = tmp1[ 0 ] * (tmp21[ 0 ])[ 0 ];
    const auto tmp25 = tmp24 + tmp24;
    const auto tmp26 = tmp25 + tmp23;
    const auto tmp27 = tmp26 / tmp20;
    const auto tmp28 = tmp27 * (tmp9 < tmp3 ? 1 : 0.0);
    const auto tmp29 = -1 * (tmp21[ 0 ])[ 0 ];
    const auto tmp30 = -1 * (tmp9 < tmp3 ? 1 : 0.0);
    const auto tmp31 = 1.0 + tmp30;
    const auto tmp32 = tmp31 * tmp29;
    const auto tmp33 = tmp32 + tmp28;
    const auto tmp34 = 3 * tmp33;
    const auto tmp35 = tmp34 / tmp0;
    const auto tmp36 = tmp35 * tmp19;
    const auto tmp37 = -1 * tmp36;
    const auto tmp38 = 0.5 * tmp37;
    const auto tmp39 = -1 * tmp38;
    const auto tmp40 = tmp39 * tmp38;
    const auto tmp41 = 2 * tmp27;
    const auto tmp42 = tmp41 * tmp27;
    const auto tmp43 = -1 * tmp42;
    typename CoefficientFunctionSpaceType< 0 >::HessianRangeType tmp44 = hessianCoefficient< 0 >( x );
    const auto tmp45 = tmp1[ 1 ] * ((tmp44[ 1 ])[ 0 ])[ 0 ];
    const auto tmp46 = (tmp21[ 1 ])[ 0 ] * (tmp21[ 1 ])[ 0 ];
    const auto tmp47 = tmp46 + tmp45;
    const auto tmp48 = tmp47 + tmp47;
    const auto tmp49 = tmp1[ 0 ] * ((tmp44[ 0 ])[ 0 ])[ 0 ];
    const auto tmp50 = (tmp21[ 0 ])[ 0 ] * (tmp21[ 0 ])[ 0 ];
    const auto tmp51 = tmp50 + tmp49;
    const auto tmp52 = tmp51 + tmp51;
    const auto tmp53 = tmp52 + tmp48;
    const auto tmp54 = tmp53 + tmp43;
    const auto tmp55 = tmp54 / tmp20;
    const auto tmp56 = tmp55 * (tmp9 < tmp3 ? 1 : 0.0);
    const auto tmp57 = -1 * ((tmp44[ 0 ])[ 0 ])[ 0 ];
    const auto tmp58 = tmp31 * tmp57;
    const auto tmp59 = tmp58 + tmp56;
    const auto tmp60 = 3 * tmp59;
    const auto tmp61 = tmp60 / tmp0;
    const auto tmp62 = tmp61 * tmp19;
    const auto tmp63 = std::sinh( tmp12 );
    const auto tmp64 = tmp35 * tmp63;
    const auto tmp65 = 2.0 * tmp64;
    const auto tmp66 = std::sinh( tmp13 );
    const auto tmp67 = 2.0 * tmp35;
    const auto tmp68 = tmp67 * tmp66;
    const auto tmp69 = tmp68 * tmp18;
    const auto tmp70 = -1 * tmp69;
    const auto tmp71 = tmp70 + tmp65;
    const auto tmp72 = tmp71 / tmp15;
    const auto tmp73 = 2 * tmp72;
    const auto tmp74 = tmp73 * tmp18;
    const auto tmp75 = tmp74 * tmp35;
    const auto tmp76 = tmp75 + tmp62;
    const auto tmp77 = -1 * tmp76;
    const auto tmp78 = 0.5 * tmp77;
    const auto tmp79 = -1 * tmp78;
    const auto tmp80 = std::tanh( tmp12 );
    const auto tmp81 = -1 * tmp80;
    const auto tmp82 = 1 + tmp81;
    const auto tmp83 = 0.5 * tmp82;
    const auto tmp84 = tmp83 * tmp79;
    const auto tmp85 = tmp84 + tmp40;
    const auto tmp86 = -1 * tmp83;
    const auto tmp87 = 1 + tmp86;
    const auto tmp88 = tmp87 * tmp78;
    const auto tmp89 = tmp88 + tmp40;
    const auto tmp90 = tmp89 + tmp85;
    const auto tmp91 = tmp1[ 1 ] * (tmp21[ 1 ])[ 1 ];
    const auto tmp92 = tmp91 + tmp91;
    const auto tmp93 = tmp1[ 0 ] * (tmp21[ 0 ])[ 1 ];
    const auto tmp94 = tmp93 + tmp93;
    const auto tmp95 = tmp94 + tmp92;
    const auto tmp96 = tmp95 / tmp20;
    const auto tmp97 = tmp96 * (tmp9 < tmp3 ? 1 : 0.0);
    const auto tmp98 = -1 * (tmp21[ 0 ])[ 1 ];
    const auto tmp99 = tmp31 * tmp98;
    const auto tmp100 = tmp99 + tmp97;
    const auto tmp101 = 3 * tmp100;
    const auto tmp102 = tmp101 / tmp0;
    const auto tmp103 = tmp102 * tmp19;
    const auto tmp104 = -1 * tmp103;
    const auto tmp105 = 0.5 * tmp104;
    const auto tmp106 = tmp39 * tmp105;
    const auto tmp107 = 2 * tmp96;
    const auto tmp108 = tmp107 * tmp27;
    const auto tmp109 = -1 * tmp108;
    const auto tmp110 = (tmp21[ 1 ])[ 0 ] * (tmp21[ 1 ])[ 1 ];
    const auto tmp111 = tmp1[ 1 ] * ((tmp44[ 1 ])[ 0 ])[ 1 ];
    const auto tmp112 = tmp111 + tmp110;
    const auto tmp113 = tmp112 + tmp112;
    const auto tmp114 = (tmp21[ 0 ])[ 0 ] * (tmp21[ 0 ])[ 1 ];
    const auto tmp115 = tmp1[ 0 ] * ((tmp44[ 0 ])[ 0 ])[ 1 ];
    const auto tmp116 = tmp115 + tmp114;
    const auto tmp117 = tmp116 + tmp116;
    const auto tmp118 = tmp117 + tmp113;
    const auto tmp119 = tmp118 + tmp109;
    const auto tmp120 = tmp119 / tmp20;
    const auto tmp121 = tmp120 * (tmp9 < tmp3 ? 1 : 0.0);
    const auto tmp122 = -1 * ((tmp44[ 0 ])[ 0 ])[ 1 ];
    const auto tmp123 = tmp31 * tmp122;
    const auto tmp124 = tmp123 + tmp121;
    const auto tmp125 = 3 * tmp124;
    const auto tmp126 = tmp125 / tmp0;
    const auto tmp127 = tmp126 * tmp19;
    const auto tmp128 = tmp102 * tmp63;
    const auto tmp129 = 2.0 * tmp128;
    const auto tmp130 = 2.0 * tmp102;
    const auto tmp131 = tmp130 * tmp66;
    const auto tmp132 = tmp131 * tmp18;
    const auto tmp133 = -1 * tmp132;
    const auto tmp134 = tmp133 + tmp129;
    const auto tmp135 = tmp134 / tmp15;
    const auto tmp136 = 2 * tmp135;
    const auto tmp137 = tmp136 * tmp18;
    const auto tmp138 = tmp137 * tmp35;
    const auto tmp139 = tmp138 + tmp127;
    const auto tmp140 = -1 * tmp139;
    const auto tmp141 = 0.5 * tmp140;
    const auto tmp142 = -1 * tmp141;
    const auto tmp143 = tmp83 * tmp142;
    const auto tmp144 = tmp143 + tmp106;
    const auto tmp145 = -1 * tmp105;
    const auto tmp146 = tmp145 * tmp38;
    const auto tmp147 = tmp87 * tmp141;
    const auto tmp148 = tmp147 + tmp146;
    const auto tmp149 = tmp148 + tmp144;
    const auto tmp150 = tmp41 * tmp96;
    const auto tmp151 = -1 * tmp150;
    const auto tmp152 = tmp1[ 1 ] * ((tmp44[ 1 ])[ 1 ])[ 0 ];
    const auto tmp153 = tmp110 + tmp152;
    const auto tmp154 = tmp153 + tmp153;
    const auto tmp155 = tmp1[ 0 ] * ((tmp44[ 0 ])[ 1 ])[ 0 ];
    const auto tmp156 = tmp114 + tmp155;
    const auto tmp157 = tmp156 + tmp156;
    const auto tmp158 = tmp157 + tmp154;
    const auto tmp159 = tmp158 + tmp151;
    const auto tmp160 = tmp159 / tmp20;
    const auto tmp161 = tmp160 * (tmp9 < tmp3 ? 1 : 0.0);
    const auto tmp162 = -1 * ((tmp44[ 0 ])[ 1 ])[ 0 ];
    const auto tmp163 = tmp31 * tmp162;
    const auto tmp164 = tmp163 + tmp161;
    const auto tmp165 = 3 * tmp164;
    const auto tmp166 = tmp165 / tmp0;
    const auto tmp167 = tmp166 * tmp19;
    const auto tmp168 = tmp74 * tmp102;
    const auto tmp169 = tmp168 + tmp167;
    const auto tmp170 = -1 * tmp169;
    const auto tmp171 = 0.5 * tmp170;
    const auto tmp172 = tmp87 * tmp171;
    const auto tmp173 = tmp172 + tmp106;
    const auto tmp174 = -1 * tmp171;
    const auto tmp175 = tmp83 * tmp174;
    const auto tmp176 = tmp175 + tmp146;
    const auto tmp177 = tmp176 + tmp173;
    const auto tmp178 = tmp145 * tmp105;
    const auto tmp179 = tmp107 * tmp96;
    const auto tmp180 = -1 * tmp179;
    const auto tmp181 = tmp1[ 1 ] * ((tmp44[ 1 ])[ 1 ])[ 1 ];
    const auto tmp182 = (tmp21[ 1 ])[ 1 ] * (tmp21[ 1 ])[ 1 ];
    const auto tmp183 = tmp182 + tmp181;
    const auto tmp184 = tmp183 + tmp183;
    const auto tmp185 = tmp1[ 0 ] * ((tmp44[ 0 ])[ 1 ])[ 1 ];
    const auto tmp186 = (tmp21[ 0 ])[ 1 ] * (tmp21[ 0 ])[ 1 ];
    const auto tmp187 = tmp186 + tmp185;
    const auto tmp188 = tmp187 + tmp187;
    const auto tmp189 = tmp188 + tmp184;
    const auto tmp190 = tmp189 + tmp180;
    const auto tmp191 = tmp190 / tmp20;
    const auto tmp192 = tmp191 * (tmp9 < tmp3 ? 1 : 0.0);
    const auto tmp193 = -1 * ((tmp44[ 0 ])[ 1 ])[ 1 ];
    const auto tmp194 = tmp31 * tmp193;
    const auto tmp195 = tmp194 + tmp192;
    const auto tmp196 = 3 * tmp195;
    const auto tmp197 = tmp196 / tmp0;
    const auto tmp198 = tmp197 * tmp19;
    const auto tmp199 = tmp137 * tmp102;
    const auto tmp200 = tmp199 + tmp198;
    const auto tmp201 = -1 * tmp200;
    const auto tmp202 = 0.5 * tmp201;
    const auto tmp203 = -1 * tmp202;
    const auto tmp204 = tmp83 * tmp203;
    const auto tmp205 = tmp204 + tmp178;
    const auto tmp206 = tmp87 * tmp202;
    const auto tmp207 = tmp206 + tmp178;
    const auto tmp208 = tmp207 + tmp205;
    ((result[ 0 ])[ 0 ])[ 0 ] = tmp90;
    ((result[ 0 ])[ 0 ])[ 1 ] = tmp149;
    ((result[ 0 ])[ 1 ])[ 0 ] = tmp177;
    ((result[ 0 ])[ 1 ])[ 1 ] = tmp208;
  }

  template< std::size_t i >
  const ConstantType< i > &constant () const
  {
    return *std::get< i >( constants_ );
  }

  template< std::size_t i >
  ConstantType< i > &constant ()
  {
    return *std::get< i >( constants_ );
  }

  const Conepsilon &conepsilon () const
  {
    return *std::get< 0 >( constants_ );
  }

  Conepsilon &conepsilon ()
  {
    return *std::get< 0 >( constants_ );
  }

  template< std::size_t i, class Point >
  typename CoefficientFunctionSpaceType< i >::RangeType evaluateCoefficient ( const Point &x ) const
  {
    typename CoefficientFunctionSpaceType< i >::RangeType result;
    std::get< i >( coefficients_ ).evaluate( x, result );;
    return result;
  }

  template< std::size_t i, class Point >
  typename CoefficientFunctionSpaceType< i >::JacobianRangeType jacobianCoefficient ( const Point &x ) const
  {
    typename CoefficientFunctionSpaceType< i >::JacobianRangeType result;
    std::get< i >( coefficients_ ).jacobian( x, result );;
    return result;
  }

  template< std::size_t i, class Point >
  typename CoefficientFunctionSpaceType< i >::HessianRangeType hessianCoefficient ( const Point &x ) const
  {
    typename CoefficientFunctionSpaceType< i >::HessianRangeType result;
    std::get< i >( coefficients_ ).hessian( x, result );;
    return result;
  }
  ConstantTupleType constants_;
  std::tuple< Dune::Fem::ConstLocalFunction< Coeffbndproj > > coefficients_;
};

} // namespace UFLLocalFunctions_5591a2c803b9658084d8f11d44bf3ae1

PYBIND11_MODULE( localfunction_5591a2c803b9658084d8f11d44bf3ae1_a524c1196983e65de1c06d7d6afdeb44, module )
{
  typedef UFLLocalFunctions_5591a2c803b9658084d8f11d44bf3ae1::UFLLocalFunction< typename Dune::FemPy::GridPart< Dune::Fem::FilteredGridPart< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > >, Dune::Fem::SimpleFilter< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > > >, true > >, Dune::FemPy::VirtualizedGridFunction< Dune::FemPy::GridPart<Dune::Fem::FilteredGridPart< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > >, Dune::Fem::SimpleFilter< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > > >, true >>, Dune::FieldVector< double, 2 > > > LocalFunctionType;
  if constexpr( LocalFunctionType::gridPartValid )
  {
      auto cls = Dune::Python::insertClass<LocalFunctionType>(module,"UFLLocalFunction",Dune::Python::GenerateTypeName("UFLLocalFunctions_5591a2c803b9658084d8f11d44bf3ae1::UFLLocalFunction< typename Dune::FemPy::GridPart< Dune::Fem::FilteredGridPart< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > >, Dune::Fem::SimpleFilter< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > > >, true > >, Dune::FemPy::VirtualizedGridFunction< Dune::FemPy::GridPart<Dune::Fem::FilteredGridPart< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > >, Dune::Fem::SimpleFilter< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > > >, true >>, Dune::FieldVector< double, 2 > > >"), Dune::Python::IncludeFiles({"python/dune/generated/localfunction_5591a2c803b9658084d8f11d44bf3ae1_a524c1196983e65de1c06d7d6afdeb44.cc"})).first;
      Dune::FemPy::registerUFLLocalFunction( module, cls );
      cls.def( pybind11::init( [] ( pybind11::object gridView, const std::string &name, int order, const Dune::FemPy::VirtualizedGridFunction< Dune::FemPy::GridPart<Dune::Fem::FilteredGridPart< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > >, Dune::Fem::SimpleFilter< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > > >, true >>, Dune::FieldVector< double, 2 > > &coeffbndproj ) {return new LocalFunctionType( Dune::FemPy::gridPart<Dune::Fem::FilteredGridPart< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > >, Dune::Fem::SimpleFilter< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > > >, true >>(gridView),name,order, coeffbndproj); } ), pybind11::keep_alive< 1, 2 >(), pybind11::keep_alive< 1, 3 >() );
      cls.def_property( "epsilon", [] ( LocalFunctionType &self ) -> UFLLocalFunctions_5591a2c803b9658084d8f11d44bf3ae1::UFLLocalFunction< typename Dune::FemPy::GridPart< Dune::Fem::FilteredGridPart< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > >, Dune::Fem::SimpleFilter< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > > >, true > >, Dune::FemPy::VirtualizedGridFunction< Dune::FemPy::GridPart<Dune::Fem::FilteredGridPart< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > >, Dune::Fem::SimpleFilter< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > > >, true >>, Dune::FieldVector< double, 2 > > >::Conepsilon { return self.conepsilon(); }, [] ( LocalFunctionType &self, const UFLLocalFunctions_5591a2c803b9658084d8f11d44bf3ae1::UFLLocalFunction< typename Dune::FemPy::GridPart< Dune::Fem::FilteredGridPart< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > >, Dune::Fem::SimpleFilter< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > > >, true > >, Dune::FemPy::VirtualizedGridFunction< Dune::FemPy::GridPart<Dune::Fem::FilteredGridPart< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > >, Dune::Fem::SimpleFilter< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > > >, true >>, Dune::FieldVector< double, 2 > > >::Conepsilon &v ) { self.conepsilon() = v; } );
      cls.def_property_readonly( "virtualized", [] ( LocalFunctionType& ) -> bool { return true;});
  }
}

#endif
