#ifndef GUARD_76e8db0f046ac9e37a793e0bb13eea7b
#define GUARD_76e8db0f046ac9e37a793e0bb13eea7b

#define USING_DUNE_PYTHON 1
#include <config.h>
#include <dune/alugrid/dgf.hh>
#include <dune/alugrid/grid.hh>
#include <dune/fem/gridpart/adaptiveleafgridpart.hh>
#include <dune/fem/gridpart/filter/simple.hh>
#include <dune/fem/gridpart/filteredgridpart.hh>
#include <dune/fempy/py/gridview.hh>
#include <dune/python/grid/gridview.hh>
#include <dune/python/grid/hierarchical.hh>
#include <dune/fem/function/localfunction/bindable.hh>
#include <dune/fem/common/intersectionside.hh>
#include <dune/python/pybind11/pybind11.h>
#include <dune/python/pybind11/extensions.h>
#include <dune/fempy/py/grid/gridpart.hh>
#include <dune/common/exceptions.hh>
#include <dune/fempy/function/virtualizedgridfunction.hh>
#include <dune/fempy/py/ufllocalfunction.hh>

namespace UFLLocalFunctions_76e8db0f046ac9e37a793e0bb13eea7b
{

  // UFLLocalFunction
// ----------------

template< class GridPart, class Coeff_tmp >
struct UFLLocalFunction
  : public Dune::Fem::BindableGridFunctionWithSpace<GridPart,Dune::Dim<1>>
{
  typedef GridPart GridPartType;
  typedef typename GridPartType::GridViewType GridView;
  typedef typename GridView::ctype ctype;
  typedef Dune::Fem::BindableGridFunctionWithSpace<GridPart,Dune::Dim<1>> BaseType;
  typedef Dune::Fem::GridFunctionSpace<GridPartType,Dune::Dim<1>> FunctionSpaceType;
  typedef typename GridPartType::template Codim< 0 >::EntityType EntityType;
  typedef typename GridPartType::IntersectionType IntersectionType;
  typedef typename EntityType::Geometry Geometry;
  typedef typename Geometry::GlobalCoordinate GlobalCoordinateType;
  typedef Dune::Fem::IntersectionSide Side;
  typedef double Conlmbda;
  typedef std::tuple< std::shared_ptr< Conlmbda > > ConstantTupleType;
  template< std::size_t i >
  using ConstantsRangeType = typename std::tuple_element_t< i, ConstantTupleType >::element_type;
  typedef std::tuple< Dune::Fem::GridFunctionSpace< GridPartType, Dune::FieldVector< double, 2 > > > CoefficientFunctionSpaceTupleType;
  typedef std::tuple< Coeff_tmp > CoefficientTupleType;
  template< std::size_t i >
  using CoefficientFunctionSpaceType = std::tuple_element_t< i, CoefficientFunctionSpaceTupleType >;
  template< std::size_t i >
  using CoefficientRangeType = typename CoefficientFunctionSpaceType< i >::RangeType;
  template< std::size_t i >
  using CoefficientJacobianRangeType = typename CoefficientFunctionSpaceType< i >::JacobianRangeType;
  static constexpr bool gridPartValid = Dune::Fem::checkGridPartValid<GridPartType,Dune::Fem::ConstLocalFunction<Coeff_tmp>>();
  template< std::size_t i >
  using CoefficientType = std::tuple_element_t< i, CoefficientTupleType >;
  template< std::size_t i >
  using ConstantType = typename std::tuple_element_t< i, ConstantTupleType >::element_type;
  using BaseType::entity;
  using BaseType::geometry;

  UFLLocalFunction ( const GridPartType &gridPart, const std::string &name, int order, const Coeff_tmp &coeff_tmp, const Dune::Fem::ParameterReader &parameter = Dune::Fem::Parameter::container() )
    : BaseType(gridPart,name,order),
      coefficients_( Dune::Fem::ConstLocalFunction< Coeff_tmp >( coeff_tmp ) )
  {
    std::get< 0 >( constants_ ) = std::make_shared< Conlmbda >( (Conlmbda(0)) );
  }

  void bind ( const IntersectionType &intersection, Side side )
  {
    BaseType::bind(intersection, side);
    std::get< 0 >( coefficients_ ).bind( this->entity() );
  }

  void bind ( const EntityType &entity )
  {
    BaseType::bind(entity);
    std::get< 0 >( coefficients_ ).bind( this->entity() );
  }

  void unbind ()
  {
    BaseType::unbind();
    std::get< 0 >( coefficients_ ).unbind();
  }

  template< class Point >
  void evaluate ( const Point &x, typename FunctionSpaceType::RangeType &result ) const
  {
    using std::max;
    using std::min;
    using std::sqrt;
    GlobalCoordinateType tmp0 = geometry().global( Dune::Fem::coordinate( x ) );
    const auto tmp1 = tmp0[ 1 ] * tmp0[ 1 ];
    const auto tmp2 = tmp0[ 0 ] * tmp0[ 0 ];
    const auto tmp3 = tmp2 + tmp1;
    const auto tmp4 = 1e-10 + tmp3;
    const auto tmp5 = std::sqrt( tmp4 );
    const auto tmp6 = -0.4 + tmp5;
    const auto tmp7 = 0.15 + tmp0[ 1 ];
    const auto tmp8 = tmp7 * tmp7;
    const auto tmp9 = 0.15 + tmp0[ 0 ];
    const auto tmp10 = tmp9 * tmp9;
    const auto tmp11 = tmp10 + tmp8;
    const auto tmp12 = 1e-10 + tmp11;
    const auto tmp13 = std::sqrt( tmp12 );
    const auto tmp14 = -0.3 + tmp13;
    const auto tmp15 = -0.15 + tmp0[ 1 ];
    const auto tmp16 = tmp15 * tmp15;
    const auto tmp17 = -0.15 + tmp0[ 0 ];
    const auto tmp18 = tmp17 * tmp17;
    const auto tmp19 = tmp18 + tmp16;
    const auto tmp20 = 1e-10 + tmp19;
    const auto tmp21 = std::sqrt( tmp20 );
    const auto tmp22 = -0.3 + tmp21;
    const auto tmp23 = std::min( tmp22, tmp14 );
    const auto tmp24 = std::max( tmp23, tmp6 );
    double tmp25 = constant< 0 >();
    const auto tmp26 = tmp25 / 2;
    typename CoefficientFunctionSpaceType< 0 >::JacobianRangeType tmp27 = jacobianCoefficient< 0 >( x );
    const auto tmp28 = (tmp27[ 0 ])[ 1 ] * (tmp27[ 0 ])[ 1 ];
    const auto tmp29 = (tmp27[ 0 ])[ 0 ] * (tmp27[ 0 ])[ 0 ];
    const auto tmp30 = tmp29 + tmp28;
    const auto tmp31 = tmp30 * tmp26;
    typename CoefficientFunctionSpaceType< 0 >::RangeType tmp32 = evaluateCoefficient< 0 >( x );
    const auto tmp33 = tmp32[ 0 ] * tmp32[ 0 ];
    const auto tmp34 = 100 * tmp33;
    const auto tmp35 = -1 * tmp32[ 0 ];
    const auto tmp36 = 1 + tmp35;
    const auto tmp37 = tmp36 * tmp36;
    const auto tmp38 = tmp37 * tmp34;
    const auto tmp39 = tmp38 + tmp31;
    const auto tmp40 = tmp39 * (tmp24 <= 0.0 ? 1 : 0.0);
    result[ 0 ] = tmp40;
  }

  template< class Point >
  void jacobian ( const Point &x, typename FunctionSpaceType::JacobianRangeType &result ) const
  {
    using std::max;
    using std::min;
    using std::sqrt;
    GlobalCoordinateType tmp0 = geometry().global( Dune::Fem::coordinate( x ) );
    const auto tmp1 = tmp0[ 1 ] * tmp0[ 1 ];
    const auto tmp2 = tmp0[ 0 ] * tmp0[ 0 ];
    const auto tmp3 = tmp2 + tmp1;
    const auto tmp4 = 1e-10 + tmp3;
    const auto tmp5 = std::sqrt( tmp4 );
    const auto tmp6 = -0.4 + tmp5;
    const auto tmp7 = 0.15 + tmp0[ 1 ];
    const auto tmp8 = tmp7 * tmp7;
    const auto tmp9 = 0.15 + tmp0[ 0 ];
    const auto tmp10 = tmp9 * tmp9;
    const auto tmp11 = tmp10 + tmp8;
    const auto tmp12 = 1e-10 + tmp11;
    const auto tmp13 = std::sqrt( tmp12 );
    const auto tmp14 = -0.3 + tmp13;
    const auto tmp15 = -0.15 + tmp0[ 1 ];
    const auto tmp16 = tmp15 * tmp15;
    const auto tmp17 = -0.15 + tmp0[ 0 ];
    const auto tmp18 = tmp17 * tmp17;
    const auto tmp19 = tmp18 + tmp16;
    const auto tmp20 = 1e-10 + tmp19;
    const auto tmp21 = std::sqrt( tmp20 );
    const auto tmp22 = -0.3 + tmp21;
    const auto tmp23 = std::min( tmp22, tmp14 );
    const auto tmp24 = std::max( tmp23, tmp6 );
    double tmp25 = constant< 0 >();
    const auto tmp26 = tmp25 / 2;
    typename CoefficientFunctionSpaceType< 0 >::HessianRangeType tmp27 = hessianCoefficient< 0 >( x );
    typename CoefficientFunctionSpaceType< 0 >::JacobianRangeType tmp28 = jacobianCoefficient< 0 >( x );
    const auto tmp29 = (tmp28[ 0 ])[ 1 ] * ((tmp27[ 0 ])[ 1 ])[ 0 ];
    const auto tmp30 = ((tmp27[ 0 ])[ 1 ])[ 0 ] * (tmp28[ 0 ])[ 1 ];
    const auto tmp31 = tmp30 + tmp29;
    const auto tmp32 = (tmp28[ 0 ])[ 0 ] * ((tmp27[ 0 ])[ 0 ])[ 0 ];
    const auto tmp33 = ((tmp27[ 0 ])[ 0 ])[ 0 ] * (tmp28[ 0 ])[ 0 ];
    const auto tmp34 = tmp33 + tmp32;
    const auto tmp35 = tmp34 + tmp31;
    const auto tmp36 = tmp35 * tmp26;
    typename CoefficientFunctionSpaceType< 0 >::RangeType tmp37 = evaluateCoefficient< 0 >( x );
    const auto tmp38 = tmp37[ 0 ] * tmp37[ 0 ];
    const auto tmp39 = 100 * tmp38;
    const auto tmp40 = -1 * (tmp28[ 0 ])[ 0 ];
    const auto tmp41 = -1 * tmp37[ 0 ];
    const auto tmp42 = 1 + tmp41;
    const auto tmp43 = tmp42 * tmp40;
    const auto tmp44 = tmp43 + tmp43;
    const auto tmp45 = tmp44 * tmp39;
    const auto tmp46 = tmp37[ 0 ] * (tmp28[ 0 ])[ 0 ];
    const auto tmp47 = tmp46 + tmp46;
    const auto tmp48 = 100 * tmp47;
    const auto tmp49 = tmp42 * tmp42;
    const auto tmp50 = tmp49 * tmp48;
    const auto tmp51 = tmp50 + tmp45;
    const auto tmp52 = tmp51 + tmp36;
    const auto tmp53 = tmp52 * (tmp24 <= 0.0 ? 1 : 0.0);
    const auto tmp54 = (tmp28[ 0 ])[ 1 ] * ((tmp27[ 0 ])[ 1 ])[ 1 ];
    const auto tmp55 = ((tmp27[ 0 ])[ 1 ])[ 1 ] * (tmp28[ 0 ])[ 1 ];
    const auto tmp56 = tmp55 + tmp54;
    const auto tmp57 = (tmp28[ 0 ])[ 0 ] * ((tmp27[ 0 ])[ 0 ])[ 1 ];
    const auto tmp58 = ((tmp27[ 0 ])[ 0 ])[ 1 ] * (tmp28[ 0 ])[ 0 ];
    const auto tmp59 = tmp58 + tmp57;
    const auto tmp60 = tmp59 + tmp56;
    const auto tmp61 = tmp60 * tmp26;
    const auto tmp62 = -1 * (tmp28[ 0 ])[ 1 ];
    const auto tmp63 = tmp42 * tmp62;
    const auto tmp64 = tmp63 + tmp63;
    const auto tmp65 = tmp64 * tmp39;
    const auto tmp66 = tmp37[ 0 ] * (tmp28[ 0 ])[ 1 ];
    const auto tmp67 = tmp66 + tmp66;
    const auto tmp68 = 100 * tmp67;
    const auto tmp69 = tmp49 * tmp68;
    const auto tmp70 = tmp69 + tmp65;
    const auto tmp71 = tmp70 + tmp61;
    const auto tmp72 = tmp71 * (tmp24 <= 0.0 ? 1 : 0.0);
    (result[ 0 ])[ 0 ] = tmp53;
    (result[ 0 ])[ 1 ] = tmp72;
  }

  template< class Point >
  void hessian ( const Point &x, typename FunctionSpaceType::HessianRangeType &result ) const
  {
    DUNE_THROW(Dune::NotImplemented,"hessian method could not be generated for local function (TooHighDerivative('CodeGenerator does not allow for third order derivatives, yet.'))");
    result=typename FunctionSpaceType::HessianRangeType(0);
  }

  template< std::size_t i >
  const ConstantType< i > &constant () const
  {
    return *std::get< i >( constants_ );
  }

  template< std::size_t i >
  ConstantType< i > &constant ()
  {
    return *std::get< i >( constants_ );
  }

  const Conlmbda &conlmbda () const
  {
    return *std::get< 0 >( constants_ );
  }

  Conlmbda &conlmbda ()
  {
    return *std::get< 0 >( constants_ );
  }

  template< std::size_t i, class Point >
  typename CoefficientFunctionSpaceType< i >::RangeType evaluateCoefficient ( const Point &x ) const
  {
    typename CoefficientFunctionSpaceType< i >::RangeType result;
    std::get< i >( coefficients_ ).evaluate( x, result );;
    return result;
  }

  template< std::size_t i, class Point >
  typename CoefficientFunctionSpaceType< i >::JacobianRangeType jacobianCoefficient ( const Point &x ) const
  {
    typename CoefficientFunctionSpaceType< i >::JacobianRangeType result;
    std::get< i >( coefficients_ ).jacobian( x, result );;
    return result;
  }

  template< std::size_t i, class Point >
  typename CoefficientFunctionSpaceType< i >::HessianRangeType hessianCoefficient ( const Point &x ) const
  {
    typename CoefficientFunctionSpaceType< i >::HessianRangeType result;
    std::get< i >( coefficients_ ).hessian( x, result );;
    return result;
  }
  ConstantTupleType constants_;
  std::tuple< Dune::Fem::ConstLocalFunction< Coeff_tmp > > coefficients_;
};

} // namespace UFLLocalFunctions_76e8db0f046ac9e37a793e0bb13eea7b

PYBIND11_MODULE( localfunction_76e8db0f046ac9e37a793e0bb13eea7b_a524c1196983e65de1c06d7d6afdeb44, module )
{
  typedef UFLLocalFunctions_76e8db0f046ac9e37a793e0bb13eea7b::UFLLocalFunction< typename Dune::FemPy::GridPart< Dune::Fem::FilteredGridPart< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > >, Dune::Fem::SimpleFilter< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > > >, true > >, Dune::FemPy::VirtualizedGridFunction< Dune::FemPy::GridPart<Dune::Fem::FilteredGridPart< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > >, Dune::Fem::SimpleFilter< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > > >, true >>, Dune::FieldVector< double, 2 > > > LocalFunctionType;
  if constexpr( LocalFunctionType::gridPartValid )
  {
      auto cls = Dune::Python::insertClass<LocalFunctionType>(module,"UFLLocalFunction",Dune::Python::GenerateTypeName("UFLLocalFunctions_76e8db0f046ac9e37a793e0bb13eea7b::UFLLocalFunction< typename Dune::FemPy::GridPart< Dune::Fem::FilteredGridPart< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > >, Dune::Fem::SimpleFilter< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > > >, true > >, Dune::FemPy::VirtualizedGridFunction< Dune::FemPy::GridPart<Dune::Fem::FilteredGridPart< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > >, Dune::Fem::SimpleFilter< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > > >, true >>, Dune::FieldVector< double, 2 > > >"), Dune::Python::IncludeFiles({"python/dune/generated/localfunction_76e8db0f046ac9e37a793e0bb13eea7b_a524c1196983e65de1c06d7d6afdeb44.cc"})).first;
      Dune::FemPy::registerUFLLocalFunction( module, cls );
      cls.def( pybind11::init( [] ( pybind11::object gridView, const std::string &name, int order, const Dune::FemPy::VirtualizedGridFunction< Dune::FemPy::GridPart<Dune::Fem::FilteredGridPart< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > >, Dune::Fem::SimpleFilter< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > > >, true >>, Dune::FieldVector< double, 2 > > &coeff_tmp ) {return new LocalFunctionType( Dune::FemPy::gridPart<Dune::Fem::FilteredGridPart< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > >, Dune::Fem::SimpleFilter< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > > >, true >>(gridView),name,order, coeff_tmp); } ), pybind11::keep_alive< 1, 2 >(), pybind11::keep_alive< 1, 3 >() );
      cls.def_property( "lmbda", [] ( LocalFunctionType &self ) -> UFLLocalFunctions_76e8db0f046ac9e37a793e0bb13eea7b::UFLLocalFunction< typename Dune::FemPy::GridPart< Dune::Fem::FilteredGridPart< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > >, Dune::Fem::SimpleFilter< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > > >, true > >, Dune::FemPy::VirtualizedGridFunction< Dune::FemPy::GridPart<Dune::Fem::FilteredGridPart< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > >, Dune::Fem::SimpleFilter< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > > >, true >>, Dune::FieldVector< double, 2 > > >::Conlmbda { return self.conlmbda(); }, [] ( LocalFunctionType &self, const UFLLocalFunctions_76e8db0f046ac9e37a793e0bb13eea7b::UFLLocalFunction< typename Dune::FemPy::GridPart< Dune::Fem::FilteredGridPart< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > >, Dune::Fem::SimpleFilter< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > > >, true > >, Dune::FemPy::VirtualizedGridFunction< Dune::FemPy::GridPart<Dune::Fem::FilteredGridPart< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > >, Dune::Fem::SimpleFilter< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > > >, true >>, Dune::FieldVector< double, 2 > > >::Conlmbda &v ) { self.conlmbda() = v; } );
      cls.def_property_readonly( "virtualized", [] ( LocalFunctionType& ) -> bool { return true;});
  }
}

#endif
