#ifndef GUARD_7792f4273b0fd848c5a0fc9d6f12683e
#define GUARD_7792f4273b0fd848c5a0fc9d6f12683e

#define USING_DUNE_PYTHON 1
#include <config.h>
#include <dune/alugrid/dgf.hh>
#include <dune/alugrid/grid.hh>
#include <dune/fem/gridpart/adaptiveleafgridpart.hh>
#include <dune/fem/gridpart/filter/simple.hh>
#include <dune/fem/gridpart/filteredgridpart.hh>
#include <dune/fempy/py/gridview.hh>
#include <dune/python/grid/gridview.hh>
#include <dune/python/grid/hierarchical.hh>
#include <dune/fem/function/localfunction/bindable.hh>
#include <dune/fem/common/intersectionside.hh>
#include <dune/python/pybind11/pybind11.h>
#include <dune/python/pybind11/extensions.h>
#include <dune/fempy/py/grid/gridpart.hh>
#include <dune/common/exceptions.hh>
#include <dune/fempy/function/virtualizedgridfunction.hh>
#include <dune/fempy/py/ufllocalfunction.hh>

namespace UFLLocalFunctions_7792f4273b0fd848c5a0fc9d6f12683e
{

  // UFLLocalFunction
// ----------------

template< class GridPart, class Coeffu_h >
struct UFLLocalFunction
  : public Dune::Fem::BindableGridFunctionWithSpace<GridPart,Dune::Dim<3>>
{
  typedef GridPart GridPartType;
  typedef typename GridPartType::GridViewType GridView;
  typedef typename GridView::ctype ctype;
  typedef Dune::Fem::BindableGridFunctionWithSpace<GridPart,Dune::Dim<3>> BaseType;
  typedef Dune::Fem::GridFunctionSpace<GridPartType,Dune::Dim<3>> FunctionSpaceType;
  typedef typename GridPartType::template Codim< 0 >::EntityType EntityType;
  typedef typename GridPartType::IntersectionType IntersectionType;
  typedef typename EntityType::Geometry Geometry;
  typedef typename Geometry::GlobalCoordinate GlobalCoordinateType;
  typedef Dune::Fem::IntersectionSide Side;
  typedef std::tuple<> ConstantTupleType;
  typedef std::tuple< Dune::Fem::GridFunctionSpace< GridPartType, Dune::FieldVector< double, 3 > > > CoefficientFunctionSpaceTupleType;
  typedef std::tuple< Coeffu_h > CoefficientTupleType;
  template< std::size_t i >
  using CoefficientFunctionSpaceType = std::tuple_element_t< i, CoefficientFunctionSpaceTupleType >;
  template< std::size_t i >
  using CoefficientRangeType = typename CoefficientFunctionSpaceType< i >::RangeType;
  template< std::size_t i >
  using CoefficientJacobianRangeType = typename CoefficientFunctionSpaceType< i >::JacobianRangeType;
  static constexpr bool gridPartValid = Dune::Fem::checkGridPartValid<GridPartType,Dune::Fem::ConstLocalFunction<Coeffu_h>>();
  template< std::size_t i >
  using CoefficientType = std::tuple_element_t< i, CoefficientTupleType >;
  template< std::size_t i >
  using ConstantType = typename std::tuple_element_t< i, ConstantTupleType >::element_type;
  using BaseType::entity;
  using BaseType::geometry;

  UFLLocalFunction ( const GridPartType &gridPart, const std::string &name, int order, const Coeffu_h &coeffu_h, const Dune::Fem::ParameterReader &parameter = Dune::Fem::Parameter::container() )
    : BaseType(gridPart,name,order),
      coefficients_( Dune::Fem::ConstLocalFunction< Coeffu_h >( coeffu_h ) )
  {}

  void bind ( const IntersectionType &intersection, Side side )
  {
    BaseType::bind(intersection, side);
    std::get< 0 >( coefficients_ ).bind( this->entity() );
  }

  void bind ( const EntityType &entity )
  {
    BaseType::bind(entity);
    std::get< 0 >( coefficients_ ).bind( this->entity() );
  }

  void unbind ()
  {
    BaseType::unbind();
    std::get< 0 >( coefficients_ ).unbind();
  }

  template< class Point >
  void evaluate ( const Point &x, typename FunctionSpaceType::RangeType &result ) const
  {
    using std::max;
    using std::min;
    using std::sqrt;
    GlobalCoordinateType tmp0 = geometry().global( Dune::Fem::coordinate( x ) );
    const auto tmp1 = tmp0[ 1 ] * tmp0[ 1 ];
    const auto tmp2 = tmp0[ 0 ] * tmp0[ 0 ];
    const auto tmp3 = tmp2 + tmp1;
    const auto tmp4 = 1e-10 + tmp3;
    const auto tmp5 = std::sqrt( tmp4 );
    const auto tmp6 = -0.4 + tmp5;
    const auto tmp7 = 0.15 + tmp0[ 1 ];
    const auto tmp8 = tmp7 * tmp7;
    const auto tmp9 = 0.15 + tmp0[ 0 ];
    const auto tmp10 = tmp9 * tmp9;
    const auto tmp11 = tmp10 + tmp8;
    const auto tmp12 = 1e-10 + tmp11;
    const auto tmp13 = std::sqrt( tmp12 );
    const auto tmp14 = -0.3 + tmp13;
    const auto tmp15 = -0.15 + tmp0[ 1 ];
    const auto tmp16 = tmp15 * tmp15;
    const auto tmp17 = -0.15 + tmp0[ 0 ];
    const auto tmp18 = tmp17 * tmp17;
    const auto tmp19 = tmp18 + tmp16;
    const auto tmp20 = 1e-10 + tmp19;
    const auto tmp21 = std::sqrt( tmp20 );
    const auto tmp22 = -0.3 + tmp21;
    const auto tmp23 = std::min( tmp22, tmp14 );
    const auto tmp24 = std::max( tmp23, tmp6 );
    typename CoefficientFunctionSpaceType< 0 >::RangeType tmp25 = evaluateCoefficient< 0 >( x );
    const auto tmp26 = tmp25[ 0 ] * (tmp24 <= 0.0 ? 1 : 0.0);
    const auto tmp27 = tmp25[ 1 ] * (tmp24 <= 0.0 ? 1 : 0.0);
    const auto tmp28 = tmp25[ 2 ] * (tmp24 <= 0.0 ? 1 : 0.0);
    result[ 0 ] = tmp26;
    result[ 1 ] = tmp27;
    result[ 2 ] = tmp28;
  }

  template< class Point >
  void jacobian ( const Point &x, typename FunctionSpaceType::JacobianRangeType &result ) const
  {
    using std::max;
    using std::min;
    using std::sqrt;
    GlobalCoordinateType tmp0 = geometry().global( Dune::Fem::coordinate( x ) );
    const auto tmp1 = tmp0[ 1 ] * tmp0[ 1 ];
    const auto tmp2 = tmp0[ 0 ] * tmp0[ 0 ];
    const auto tmp3 = tmp2 + tmp1;
    const auto tmp4 = 1e-10 + tmp3;
    const auto tmp5 = std::sqrt( tmp4 );
    const auto tmp6 = -0.4 + tmp5;
    const auto tmp7 = 0.15 + tmp0[ 1 ];
    const auto tmp8 = tmp7 * tmp7;
    const auto tmp9 = 0.15 + tmp0[ 0 ];
    const auto tmp10 = tmp9 * tmp9;
    const auto tmp11 = tmp10 + tmp8;
    const auto tmp12 = 1e-10 + tmp11;
    const auto tmp13 = std::sqrt( tmp12 );
    const auto tmp14 = -0.3 + tmp13;
    const auto tmp15 = -0.15 + tmp0[ 1 ];
    const auto tmp16 = tmp15 * tmp15;
    const auto tmp17 = -0.15 + tmp0[ 0 ];
    const auto tmp18 = tmp17 * tmp17;
    const auto tmp19 = tmp18 + tmp16;
    const auto tmp20 = 1e-10 + tmp19;
    const auto tmp21 = std::sqrt( tmp20 );
    const auto tmp22 = -0.3 + tmp21;
    const auto tmp23 = std::min( tmp22, tmp14 );
    const auto tmp24 = std::max( tmp23, tmp6 );
    typename CoefficientFunctionSpaceType< 0 >::JacobianRangeType tmp25 = jacobianCoefficient< 0 >( x );
    const auto tmp26 = (tmp25[ 0 ])[ 0 ] * (tmp24 <= 0.0 ? 1 : 0.0);
    const auto tmp27 = (tmp25[ 0 ])[ 1 ] * (tmp24 <= 0.0 ? 1 : 0.0);
    const auto tmp28 = (tmp25[ 1 ])[ 0 ] * (tmp24 <= 0.0 ? 1 : 0.0);
    const auto tmp29 = (tmp25[ 1 ])[ 1 ] * (tmp24 <= 0.0 ? 1 : 0.0);
    const auto tmp30 = (tmp25[ 2 ])[ 0 ] * (tmp24 <= 0.0 ? 1 : 0.0);
    const auto tmp31 = (tmp25[ 2 ])[ 1 ] * (tmp24 <= 0.0 ? 1 : 0.0);
    (result[ 0 ])[ 0 ] = tmp26;
    (result[ 0 ])[ 1 ] = tmp27;
    (result[ 1 ])[ 0 ] = tmp28;
    (result[ 1 ])[ 1 ] = tmp29;
    (result[ 2 ])[ 0 ] = tmp30;
    (result[ 2 ])[ 1 ] = tmp31;
  }

  template< class Point >
  void hessian ( const Point &x, typename FunctionSpaceType::HessianRangeType &result ) const
  {
    using std::max;
    using std::min;
    using std::sqrt;
    GlobalCoordinateType tmp0 = geometry().global( Dune::Fem::coordinate( x ) );
    const auto tmp1 = tmp0[ 1 ] * tmp0[ 1 ];
    const auto tmp2 = tmp0[ 0 ] * tmp0[ 0 ];
    const auto tmp3 = tmp2 + tmp1;
    const auto tmp4 = 1e-10 + tmp3;
    const auto tmp5 = std::sqrt( tmp4 );
    const auto tmp6 = -0.4 + tmp5;
    const auto tmp7 = 0.15 + tmp0[ 1 ];
    const auto tmp8 = tmp7 * tmp7;
    const auto tmp9 = 0.15 + tmp0[ 0 ];
    const auto tmp10 = tmp9 * tmp9;
    const auto tmp11 = tmp10 + tmp8;
    const auto tmp12 = 1e-10 + tmp11;
    const auto tmp13 = std::sqrt( tmp12 );
    const auto tmp14 = -0.3 + tmp13;
    const auto tmp15 = -0.15 + tmp0[ 1 ];
    const auto tmp16 = tmp15 * tmp15;
    const auto tmp17 = -0.15 + tmp0[ 0 ];
    const auto tmp18 = tmp17 * tmp17;
    const auto tmp19 = tmp18 + tmp16;
    const auto tmp20 = 1e-10 + tmp19;
    const auto tmp21 = std::sqrt( tmp20 );
    const auto tmp22 = -0.3 + tmp21;
    const auto tmp23 = std::min( tmp22, tmp14 );
    const auto tmp24 = std::max( tmp23, tmp6 );
    typename CoefficientFunctionSpaceType< 0 >::HessianRangeType tmp25 = hessianCoefficient< 0 >( x );
    const auto tmp26 = ((tmp25[ 0 ])[ 0 ])[ 0 ] * (tmp24 <= 0.0 ? 1 : 0.0);
    const auto tmp27 = ((tmp25[ 0 ])[ 0 ])[ 1 ] * (tmp24 <= 0.0 ? 1 : 0.0);
    const auto tmp28 = ((tmp25[ 0 ])[ 1 ])[ 0 ] * (tmp24 <= 0.0 ? 1 : 0.0);
    const auto tmp29 = ((tmp25[ 0 ])[ 1 ])[ 1 ] * (tmp24 <= 0.0 ? 1 : 0.0);
    const auto tmp30 = ((tmp25[ 1 ])[ 0 ])[ 0 ] * (tmp24 <= 0.0 ? 1 : 0.0);
    const auto tmp31 = ((tmp25[ 1 ])[ 0 ])[ 1 ] * (tmp24 <= 0.0 ? 1 : 0.0);
    const auto tmp32 = ((tmp25[ 1 ])[ 1 ])[ 0 ] * (tmp24 <= 0.0 ? 1 : 0.0);
    const auto tmp33 = ((tmp25[ 1 ])[ 1 ])[ 1 ] * (tmp24 <= 0.0 ? 1 : 0.0);
    const auto tmp34 = ((tmp25[ 2 ])[ 0 ])[ 0 ] * (tmp24 <= 0.0 ? 1 : 0.0);
    const auto tmp35 = ((tmp25[ 2 ])[ 0 ])[ 1 ] * (tmp24 <= 0.0 ? 1 : 0.0);
    const auto tmp36 = ((tmp25[ 2 ])[ 1 ])[ 0 ] * (tmp24 <= 0.0 ? 1 : 0.0);
    const auto tmp37 = ((tmp25[ 2 ])[ 1 ])[ 1 ] * (tmp24 <= 0.0 ? 1 : 0.0);
    ((result[ 0 ])[ 0 ])[ 0 ] = tmp26;
    ((result[ 0 ])[ 0 ])[ 1 ] = tmp27;
    ((result[ 0 ])[ 1 ])[ 0 ] = tmp28;
    ((result[ 0 ])[ 1 ])[ 1 ] = tmp29;
    ((result[ 1 ])[ 0 ])[ 0 ] = tmp30;
    ((result[ 1 ])[ 0 ])[ 1 ] = tmp31;
    ((result[ 1 ])[ 1 ])[ 0 ] = tmp32;
    ((result[ 1 ])[ 1 ])[ 1 ] = tmp33;
    ((result[ 2 ])[ 0 ])[ 0 ] = tmp34;
    ((result[ 2 ])[ 0 ])[ 1 ] = tmp35;
    ((result[ 2 ])[ 1 ])[ 0 ] = tmp36;
    ((result[ 2 ])[ 1 ])[ 1 ] = tmp37;
  }

  template< std::size_t i >
  const ConstantType< i > &constant () const
  {
    return *std::get< i >( constants_ );
  }

  template< std::size_t i >
  ConstantType< i > &constant ()
  {
    return *std::get< i >( constants_ );
  }

  template< std::size_t i, class Point >
  typename CoefficientFunctionSpaceType< i >::RangeType evaluateCoefficient ( const Point &x ) const
  {
    typename CoefficientFunctionSpaceType< i >::RangeType result;
    std::get< i >( coefficients_ ).evaluate( x, result );;
    return result;
  }

  template< std::size_t i, class Point >
  typename CoefficientFunctionSpaceType< i >::JacobianRangeType jacobianCoefficient ( const Point &x ) const
  {
    typename CoefficientFunctionSpaceType< i >::JacobianRangeType result;
    std::get< i >( coefficients_ ).jacobian( x, result );;
    return result;
  }

  template< std::size_t i, class Point >
  typename CoefficientFunctionSpaceType< i >::HessianRangeType hessianCoefficient ( const Point &x ) const
  {
    typename CoefficientFunctionSpaceType< i >::HessianRangeType result;
    std::get< i >( coefficients_ ).hessian( x, result );;
    return result;
  }
  ConstantTupleType constants_;
  std::tuple< Dune::Fem::ConstLocalFunction< Coeffu_h > > coefficients_;
};

} // namespace UFLLocalFunctions_7792f4273b0fd848c5a0fc9d6f12683e

PYBIND11_MODULE( localfunction_7792f4273b0fd848c5a0fc9d6f12683e_a524c1196983e65de1c06d7d6afdeb44, module )
{
  typedef UFLLocalFunctions_7792f4273b0fd848c5a0fc9d6f12683e::UFLLocalFunction< typename Dune::FemPy::GridPart< Dune::Fem::FilteredGridPart< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > >, Dune::Fem::SimpleFilter< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > > >, true > >, Dune::FemPy::VirtualizedGridFunction< Dune::FemPy::GridPart<Dune::Fem::FilteredGridPart< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > >, Dune::Fem::SimpleFilter< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > > >, true >>, Dune::FieldVector< double, 3 > > > LocalFunctionType;
  if constexpr( LocalFunctionType::gridPartValid )
  {
      auto cls = Dune::Python::insertClass<LocalFunctionType>(module,"UFLLocalFunction",Dune::Python::GenerateTypeName("UFLLocalFunctions_7792f4273b0fd848c5a0fc9d6f12683e::UFLLocalFunction< typename Dune::FemPy::GridPart< Dune::Fem::FilteredGridPart< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > >, Dune::Fem::SimpleFilter< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > > >, true > >, Dune::FemPy::VirtualizedGridFunction< Dune::FemPy::GridPart<Dune::Fem::FilteredGridPart< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > >, Dune::Fem::SimpleFilter< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > > >, true >>, Dune::FieldVector< double, 3 > > >"), Dune::Python::IncludeFiles({"python/dune/generated/localfunction_7792f4273b0fd848c5a0fc9d6f12683e_a524c1196983e65de1c06d7d6afdeb44.cc"})).first;
      Dune::FemPy::registerUFLLocalFunction( module, cls );
      cls.def( pybind11::init( [] ( pybind11::object gridView, const std::string &name, int order, const Dune::FemPy::VirtualizedGridFunction< Dune::FemPy::GridPart<Dune::Fem::FilteredGridPart< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > >, Dune::Fem::SimpleFilter< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > > >, true >>, Dune::FieldVector< double, 3 > > &coeffu_h ) {return new LocalFunctionType( Dune::FemPy::gridPart<Dune::Fem::FilteredGridPart< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > >, Dune::Fem::SimpleFilter< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > > >, true >>(gridView),name,order, coeffu_h); } ), pybind11::keep_alive< 1, 2 >(), pybind11::keep_alive< 1, 3 >() );
      cls.def_property_readonly( "virtualized", [] ( LocalFunctionType& ) -> bool { return true;});
  }
}

#endif
