#ifndef GUARD_7f7ef99c50708814ba5a82b0956b0aed
#define GUARD_7f7ef99c50708814ba5a82b0956b0aed

#define USING_DUNE_PYTHON 1
#include <config.h>
#include <dune/alugrid/dgf.hh>
#include <dune/alugrid/grid.hh>
#include <dune/fem/gridpart/adaptiveleafgridpart.hh>
#include <dune/fem/gridpart/filter/simple.hh>
#include <dune/fem/gridpart/filteredgridpart.hh>
#include <dune/fempy/py/gridview.hh>
#include <dune/python/grid/gridview.hh>
#include <dune/python/grid/hierarchical.hh>
#include <dune/fem/function/localfunction/bindable.hh>
#include <dune/fem/common/intersectionside.hh>
#include <dune/python/pybind11/pybind11.h>
#include <dune/python/pybind11/extensions.h>
#include <dune/fempy/py/grid/gridpart.hh>
#include <dune/common/exceptions.hh>
#include <dune/fempy/py/ufllocalfunction.hh>

namespace UFLLocalFunctions_7f7ef99c50708814ba5a82b0956b0aed
{

  // UFLLocalFunction
// ----------------

template< class GridPart >
struct UFLLocalFunction
  : public Dune::Fem::BindableGridFunctionWithSpace<GridPart,Dune::Dim<1>>
{
  typedef GridPart GridPartType;
  typedef typename GridPartType::GridViewType GridView;
  typedef typename GridView::ctype ctype;
  typedef Dune::Fem::BindableGridFunctionWithSpace<GridPart,Dune::Dim<1>> BaseType;
  typedef Dune::Fem::GridFunctionSpace<GridPartType,Dune::Dim<1>> FunctionSpaceType;
  typedef typename GridPartType::template Codim< 0 >::EntityType EntityType;
  typedef typename GridPartType::IntersectionType IntersectionType;
  typedef typename EntityType::Geometry Geometry;
  typedef typename Geometry::GlobalCoordinate GlobalCoordinateType;
  typedef Dune::Fem::IntersectionSide Side;
  typedef double Conepsilon;
  typedef std::tuple< std::shared_ptr< Conepsilon > > ConstantTupleType;
  template< std::size_t i >
  using ConstantsRangeType = typename std::tuple_element_t< i, ConstantTupleType >::element_type;
  typedef std::tuple<> CoefficientTupleType;
  static constexpr bool gridPartValid = true;
  template< std::size_t i >
  using CoefficientType = std::tuple_element_t< i, CoefficientTupleType >;
  template< std::size_t i >
  using ConstantType = typename std::tuple_element_t< i, ConstantTupleType >::element_type;
  using BaseType::entity;
  using BaseType::geometry;

  UFLLocalFunction ( const GridPartType &gridPart, const std::string &name, int order, const Dune::Fem::ParameterReader &parameter = Dune::Fem::Parameter::container() )
    : BaseType(gridPart,name,order)
  {
    std::get< 0 >( constants_ ) = std::make_shared< Conepsilon >( (Conepsilon(0)) );
  }

  void bind ( const IntersectionType &intersection, Side side )
  {
    BaseType::bind(intersection, side);
  }

  void bind ( const EntityType &entity )
  {
    BaseType::bind(entity);
  }

  void unbind ()
  {
    BaseType::unbind();
  }

  template< class Point >
  void evaluate ( const Point &x, typename FunctionSpaceType::RangeType &result ) const
  {
    using std::max;
    using std::min;
    using std::sqrt;
    using std::tanh;
    double tmp0 = constant< 0 >();
    GlobalCoordinateType tmp1 = geometry().global( Dune::Fem::coordinate( x ) );
    const auto tmp2 = tmp1[ 1 ] * tmp1[ 1 ];
    const auto tmp3 = tmp1[ 0 ] * tmp1[ 0 ];
    const auto tmp4 = tmp3 + tmp2;
    const auto tmp5 = 1e-10 + tmp4;
    const auto tmp6 = std::sqrt( tmp5 );
    const auto tmp7 = -0.4 + tmp6;
    const auto tmp8 = 0.15 + tmp1[ 1 ];
    const auto tmp9 = tmp8 * tmp8;
    const auto tmp10 = 0.15 + tmp1[ 0 ];
    const auto tmp11 = tmp10 * tmp10;
    const auto tmp12 = tmp11 + tmp9;
    const auto tmp13 = 1e-10 + tmp12;
    const auto tmp14 = std::sqrt( tmp13 );
    const auto tmp15 = -0.3 + tmp14;
    const auto tmp16 = -0.15 + tmp1[ 1 ];
    const auto tmp17 = tmp16 * tmp16;
    const auto tmp18 = -0.15 + tmp1[ 0 ];
    const auto tmp19 = tmp18 * tmp18;
    const auto tmp20 = tmp19 + tmp17;
    const auto tmp21 = 1e-10 + tmp20;
    const auto tmp22 = std::sqrt( tmp21 );
    const auto tmp23 = -0.3 + tmp22;
    const auto tmp24 = std::min( tmp23, tmp15 );
    const auto tmp25 = std::max( tmp24, tmp7 );
    const auto tmp26 = 3 * tmp25;
    const auto tmp27 = tmp26 / tmp0;
    const auto tmp28 = std::tanh( tmp27 );
    const auto tmp29 = -1 * tmp28;
    const auto tmp30 = 1 + tmp29;
    const auto tmp31 = 0.5 * tmp30;
    const auto tmp32 = 0.9999999999 * tmp31;
    const auto tmp33 = 1e-10 + tmp32;
    result[ 0 ] = tmp33;
  }

  template< class Point >
  void jacobian ( const Point &x, typename FunctionSpaceType::JacobianRangeType &result ) const
  {
    using std::cosh;
    using std::max;
    using std::min;
    using std::pow;
    using std::sqrt;
    double tmp0 = constant< 0 >();
    GlobalCoordinateType tmp1 = geometry().global( Dune::Fem::coordinate( x ) );
    const auto tmp2 = tmp1[ 1 ] * tmp1[ 1 ];
    const auto tmp3 = tmp1[ 0 ] * tmp1[ 0 ];
    const auto tmp4 = tmp3 + tmp2;
    const auto tmp5 = 1e-10 + tmp4;
    const auto tmp6 = std::sqrt( tmp5 );
    const auto tmp7 = -0.4 + tmp6;
    const auto tmp8 = 0.15 + tmp1[ 1 ];
    const auto tmp9 = tmp8 * tmp8;
    const auto tmp10 = 0.15 + tmp1[ 0 ];
    const auto tmp11 = tmp10 * tmp10;
    const auto tmp12 = tmp11 + tmp9;
    const auto tmp13 = 1e-10 + tmp12;
    const auto tmp14 = std::sqrt( tmp13 );
    const auto tmp15 = -0.3 + tmp14;
    const auto tmp16 = -0.15 + tmp1[ 1 ];
    const auto tmp17 = tmp16 * tmp16;
    const auto tmp18 = -0.15 + tmp1[ 0 ];
    const auto tmp19 = tmp18 * tmp18;
    const auto tmp20 = tmp19 + tmp17;
    const auto tmp21 = 1e-10 + tmp20;
    const auto tmp22 = std::sqrt( tmp21 );
    const auto tmp23 = -0.3 + tmp22;
    const auto tmp24 = std::min( tmp23, tmp15 );
    const auto tmp25 = std::max( tmp24, tmp7 );
    const auto tmp26 = 3 * tmp25;
    const auto tmp27 = tmp26 / tmp0;
    const auto tmp28 = 2.0 * tmp27;
    const auto tmp29 = std::cosh( tmp28 );
    const auto tmp30 = 1.0 + tmp29;
    const auto tmp31 = std::cosh( tmp27 );
    const auto tmp32 = 2.0 * tmp31;
    const auto tmp33 = tmp32 / tmp30;
    const auto tmp34 = std::pow( tmp33, 2 );
    const auto tmp35 = 2 * tmp22;
    const auto tmp36 = tmp18 + tmp18;
    const auto tmp37 = tmp36 / tmp35;
    const auto tmp38 = tmp37 * (tmp23 < tmp15 ? 1 : 0.0);
    const auto tmp39 = 2 * tmp14;
    const auto tmp40 = tmp10 + tmp10;
    const auto tmp41 = tmp40 / tmp39;
    const auto tmp42 = -1 * (tmp23 < tmp15 ? 1 : 0.0);
    const auto tmp43 = 1.0 + tmp42;
    const auto tmp44 = tmp43 * tmp41;
    const auto tmp45 = tmp44 + tmp38;
    const auto tmp46 = tmp45 * (tmp24 > tmp7 ? 1 : 0.0);
    const auto tmp47 = 2 * tmp6;
    const auto tmp48 = tmp1[ 0 ] + tmp1[ 0 ];
    const auto tmp49 = tmp48 / tmp47;
    const auto tmp50 = -1 * (tmp24 > tmp7 ? 1 : 0.0);
    const auto tmp51 = 1.0 + tmp50;
    const auto tmp52 = tmp51 * tmp49;
    const auto tmp53 = tmp52 + tmp46;
    const auto tmp54 = 3 * tmp53;
    const auto tmp55 = tmp54 / tmp0;
    const auto tmp56 = tmp55 * tmp34;
    const auto tmp57 = -1 * tmp56;
    const auto tmp58 = 0.5 * tmp57;
    const auto tmp59 = 0.9999999999 * tmp58;
    const auto tmp60 = tmp16 + tmp16;
    const auto tmp61 = tmp60 / tmp35;
    const auto tmp62 = tmp61 * (tmp23 < tmp15 ? 1 : 0.0);
    const auto tmp63 = tmp8 + tmp8;
    const auto tmp64 = tmp63 / tmp39;
    const auto tmp65 = tmp43 * tmp64;
    const auto tmp66 = tmp65 + tmp62;
    const auto tmp67 = tmp66 * (tmp24 > tmp7 ? 1 : 0.0);
    const auto tmp68 = tmp1[ 1 ] + tmp1[ 1 ];
    const auto tmp69 = tmp68 / tmp47;
    const auto tmp70 = tmp51 * tmp69;
    const auto tmp71 = tmp70 + tmp67;
    const auto tmp72 = 3 * tmp71;
    const auto tmp73 = tmp72 / tmp0;
    const auto tmp74 = tmp73 * tmp34;
    const auto tmp75 = -1 * tmp74;
    const auto tmp76 = 0.5 * tmp75;
    const auto tmp77 = 0.9999999999 * tmp76;
    (result[ 0 ])[ 0 ] = tmp59;
    (result[ 0 ])[ 1 ] = tmp77;
  }

  template< class Point >
  void hessian ( const Point &x, typename FunctionSpaceType::HessianRangeType &result ) const
  {
    using std::cosh;
    using std::max;
    using std::min;
    using std::pow;
    using std::sinh;
    using std::sqrt;
    double tmp0 = constant< 0 >();
    GlobalCoordinateType tmp1 = geometry().global( Dune::Fem::coordinate( x ) );
    const auto tmp2 = tmp1[ 1 ] * tmp1[ 1 ];
    const auto tmp3 = tmp1[ 0 ] * tmp1[ 0 ];
    const auto tmp4 = tmp3 + tmp2;
    const auto tmp5 = 1e-10 + tmp4;
    const auto tmp6 = std::sqrt( tmp5 );
    const auto tmp7 = -0.4 + tmp6;
    const auto tmp8 = 0.15 + tmp1[ 1 ];
    const auto tmp9 = tmp8 * tmp8;
    const auto tmp10 = 0.15 + tmp1[ 0 ];
    const auto tmp11 = tmp10 * tmp10;
    const auto tmp12 = tmp11 + tmp9;
    const auto tmp13 = 1e-10 + tmp12;
    const auto tmp14 = std::sqrt( tmp13 );
    const auto tmp15 = -0.3 + tmp14;
    const auto tmp16 = -0.15 + tmp1[ 1 ];
    const auto tmp17 = tmp16 * tmp16;
    const auto tmp18 = -0.15 + tmp1[ 0 ];
    const auto tmp19 = tmp18 * tmp18;
    const auto tmp20 = tmp19 + tmp17;
    const auto tmp21 = 1e-10 + tmp20;
    const auto tmp22 = std::sqrt( tmp21 );
    const auto tmp23 = -0.3 + tmp22;
    const auto tmp24 = std::min( tmp23, tmp15 );
    const auto tmp25 = std::max( tmp24, tmp7 );
    const auto tmp26 = 3 * tmp25;
    const auto tmp27 = tmp26 / tmp0;
    const auto tmp28 = 2.0 * tmp27;
    const auto tmp29 = std::cosh( tmp28 );
    const auto tmp30 = 1.0 + tmp29;
    const auto tmp31 = std::cosh( tmp27 );
    const auto tmp32 = 2.0 * tmp31;
    const auto tmp33 = tmp32 / tmp30;
    const auto tmp34 = std::pow( tmp33, 2 );
    const auto tmp35 = 2 * tmp22;
    const auto tmp36 = tmp18 + tmp18;
    const auto tmp37 = tmp36 / tmp35;
    const auto tmp38 = 2 * tmp37;
    const auto tmp39 = tmp38 * tmp37;
    const auto tmp40 = -1 * tmp39;
    const auto tmp41 = 2 + tmp40;
    const auto tmp42 = tmp41 / tmp35;
    const auto tmp43 = tmp42 * (tmp23 < tmp15 ? 1 : 0.0);
    const auto tmp44 = 2 * tmp14;
    const auto tmp45 = tmp10 + tmp10;
    const auto tmp46 = tmp45 / tmp44;
    const auto tmp47 = 2 * tmp46;
    const auto tmp48 = tmp47 * tmp46;
    const auto tmp49 = -1 * tmp48;
    const auto tmp50 = 2 + tmp49;
    const auto tmp51 = tmp50 / tmp44;
    const auto tmp52 = -1 * (tmp23 < tmp15 ? 1 : 0.0);
    const auto tmp53 = 1.0 + tmp52;
    const auto tmp54 = tmp53 * tmp51;
    const auto tmp55 = tmp54 + tmp43;
    const auto tmp56 = tmp55 * (tmp24 > tmp7 ? 1 : 0.0);
    const auto tmp57 = 2 * tmp6;
    const auto tmp58 = tmp1[ 0 ] + tmp1[ 0 ];
    const auto tmp59 = tmp58 / tmp57;
    const auto tmp60 = 2 * tmp59;
    const auto tmp61 = tmp60 * tmp59;
    const auto tmp62 = -1 * tmp61;
    const auto tmp63 = 2 + tmp62;
    const auto tmp64 = tmp63 / tmp57;
    const auto tmp65 = -1 * (tmp24 > tmp7 ? 1 : 0.0);
    const auto tmp66 = 1.0 + tmp65;
    const auto tmp67 = tmp66 * tmp64;
    const auto tmp68 = tmp67 + tmp56;
    const auto tmp69 = 3 * tmp68;
    const auto tmp70 = tmp69 / tmp0;
    const auto tmp71 = tmp70 * tmp34;
    const auto tmp72 = tmp37 * (tmp23 < tmp15 ? 1 : 0.0);
    const auto tmp73 = tmp53 * tmp46;
    const auto tmp74 = tmp73 + tmp72;
    const auto tmp75 = tmp74 * (tmp24 > tmp7 ? 1 : 0.0);
    const auto tmp76 = tmp66 * tmp59;
    const auto tmp77 = tmp76 + tmp75;
    const auto tmp78 = 3 * tmp77;
    const auto tmp79 = tmp78 / tmp0;
    const auto tmp80 = std::sinh( tmp27 );
    const auto tmp81 = tmp79 * tmp80;
    const auto tmp82 = 2.0 * tmp81;
    const auto tmp83 = std::sinh( tmp28 );
    const auto tmp84 = 2.0 * tmp79;
    const auto tmp85 = tmp84 * tmp83;
    const auto tmp86 = tmp85 * tmp33;
    const auto tmp87 = -1 * tmp86;
    const auto tmp88 = tmp87 + tmp82;
    const auto tmp89 = tmp88 / tmp30;
    const auto tmp90 = 2 * tmp89;
    const auto tmp91 = tmp90 * tmp33;
    const auto tmp92 = tmp91 * tmp79;
    const auto tmp93 = tmp92 + tmp71;
    const auto tmp94 = -1 * tmp93;
    const auto tmp95 = 0.5 * tmp94;
    const auto tmp96 = 0.9999999999 * tmp95;
    const auto tmp97 = tmp16 + tmp16;
    const auto tmp98 = tmp97 / tmp35;
    const auto tmp99 = 2 * tmp98;
    const auto tmp100 = tmp99 * tmp37;
    const auto tmp101 = -1 * tmp100;
    const auto tmp102 = tmp101 / tmp35;
    const auto tmp103 = tmp102 * (tmp23 < tmp15 ? 1 : 0.0);
    const auto tmp104 = tmp8 + tmp8;
    const auto tmp105 = tmp104 / tmp44;
    const auto tmp106 = 2 * tmp105;
    const auto tmp107 = tmp106 * tmp46;
    const auto tmp108 = -1 * tmp107;
    const auto tmp109 = tmp108 / tmp44;
    const auto tmp110 = tmp53 * tmp109;
    const auto tmp111 = tmp110 + tmp103;
    const auto tmp112 = tmp111 * (tmp24 > tmp7 ? 1 : 0.0);
    const auto tmp113 = tmp1[ 1 ] + tmp1[ 1 ];
    const auto tmp114 = tmp113 / tmp57;
    const auto tmp115 = 2 * tmp114;
    const auto tmp116 = tmp115 * tmp59;
    const auto tmp117 = -1 * tmp116;
    const auto tmp118 = tmp117 / tmp57;
    const auto tmp119 = tmp66 * tmp118;
    const auto tmp120 = tmp119 + tmp112;
    const auto tmp121 = 3 * tmp120;
    const auto tmp122 = tmp121 / tmp0;
    const auto tmp123 = tmp122 * tmp34;
    const auto tmp124 = tmp98 * (tmp23 < tmp15 ? 1 : 0.0);
    const auto tmp125 = tmp53 * tmp105;
    const auto tmp126 = tmp125 + tmp124;
    const auto tmp127 = tmp126 * (tmp24 > tmp7 ? 1 : 0.0);
    const auto tmp128 = tmp66 * tmp114;
    const auto tmp129 = tmp128 + tmp127;
    const auto tmp130 = 3 * tmp129;
    const auto tmp131 = tmp130 / tmp0;
    const auto tmp132 = tmp131 * tmp80;
    const auto tmp133 = 2.0 * tmp132;
    const auto tmp134 = 2.0 * tmp131;
    const auto tmp135 = tmp134 * tmp83;
    const auto tmp136 = tmp135 * tmp33;
    const auto tmp137 = -1 * tmp136;
    const auto tmp138 = tmp137 + tmp133;
    const auto tmp139 = tmp138 / tmp30;
    const auto tmp140 = 2 * tmp139;
    const auto tmp141 = tmp140 * tmp33;
    const auto tmp142 = tmp141 * tmp79;
    const auto tmp143 = tmp142 + tmp123;
    const auto tmp144 = -1 * tmp143;
    const auto tmp145 = 0.5 * tmp144;
    const auto tmp146 = 0.9999999999 * tmp145;
    const auto tmp147 = tmp38 * tmp98;
    const auto tmp148 = -1 * tmp147;
    const auto tmp149 = tmp148 / tmp35;
    const auto tmp150 = tmp149 * (tmp23 < tmp15 ? 1 : 0.0);
    const auto tmp151 = tmp47 * tmp105;
    const auto tmp152 = -1 * tmp151;
    const auto tmp153 = tmp152 / tmp44;
    const auto tmp154 = tmp53 * tmp153;
    const auto tmp155 = tmp154 + tmp150;
    const auto tmp156 = tmp155 * (tmp24 > tmp7 ? 1 : 0.0);
    const auto tmp157 = tmp60 * tmp114;
    const auto tmp158 = -1 * tmp157;
    const auto tmp159 = tmp158 / tmp57;
    const auto tmp160 = tmp66 * tmp159;
    const auto tmp161 = tmp160 + tmp156;
    const auto tmp162 = 3 * tmp161;
    const auto tmp163 = tmp162 / tmp0;
    const auto tmp164 = tmp163 * tmp34;
    const auto tmp165 = tmp91 * tmp131;
    const auto tmp166 = tmp165 + tmp164;
    const auto tmp167 = -1 * tmp166;
    const auto tmp168 = 0.5 * tmp167;
    const auto tmp169 = 0.9999999999 * tmp168;
    const auto tmp170 = tmp99 * tmp98;
    const auto tmp171 = -1 * tmp170;
    const auto tmp172 = 2 + tmp171;
    const auto tmp173 = tmp172 / tmp35;
    const auto tmp174 = tmp173 * (tmp23 < tmp15 ? 1 : 0.0);
    const auto tmp175 = tmp106 * tmp105;
    const auto tmp176 = -1 * tmp175;
    const auto tmp177 = 2 + tmp176;
    const auto tmp178 = tmp177 / tmp44;
    const auto tmp179 = tmp53 * tmp178;
    const auto tmp180 = tmp179 + tmp174;
    const auto tmp181 = tmp180 * (tmp24 > tmp7 ? 1 : 0.0);
    const auto tmp182 = tmp115 * tmp114;
    const auto tmp183 = -1 * tmp182;
    const auto tmp184 = 2 + tmp183;
    const auto tmp185 = tmp184 / tmp57;
    const auto tmp186 = tmp66 * tmp185;
    const auto tmp187 = tmp186 + tmp181;
    const auto tmp188 = 3 * tmp187;
    const auto tmp189 = tmp188 / tmp0;
    const auto tmp190 = tmp189 * tmp34;
    const auto tmp191 = tmp141 * tmp131;
    const auto tmp192 = tmp191 + tmp190;
    const auto tmp193 = -1 * tmp192;
    const auto tmp194 = 0.5 * tmp193;
    const auto tmp195 = 0.9999999999 * tmp194;
    ((result[ 0 ])[ 0 ])[ 0 ] = tmp96;
    ((result[ 0 ])[ 0 ])[ 1 ] = tmp146;
    ((result[ 0 ])[ 1 ])[ 0 ] = tmp169;
    ((result[ 0 ])[ 1 ])[ 1 ] = tmp195;
  }

  template< std::size_t i >
  const ConstantType< i > &constant () const
  {
    return *std::get< i >( constants_ );
  }

  template< std::size_t i >
  ConstantType< i > &constant ()
  {
    return *std::get< i >( constants_ );
  }

  const Conepsilon &conepsilon () const
  {
    return *std::get< 0 >( constants_ );
  }

  Conepsilon &conepsilon ()
  {
    return *std::get< 0 >( constants_ );
  }
  ConstantTupleType constants_;
  std::tuple<  > coefficients_;
};

} // namespace UFLLocalFunctions_7f7ef99c50708814ba5a82b0956b0aed

PYBIND11_MODULE( localfunction_7f7ef99c50708814ba5a82b0956b0aed_a524c1196983e65de1c06d7d6afdeb44, module )
{
  typedef UFLLocalFunctions_7f7ef99c50708814ba5a82b0956b0aed::UFLLocalFunction< typename Dune::FemPy::GridPart< Dune::Fem::FilteredGridPart< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > >, Dune::Fem::SimpleFilter< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > > >, true > > > LocalFunctionType;
  if constexpr( LocalFunctionType::gridPartValid )
  {
      auto cls = Dune::Python::insertClass<LocalFunctionType>(module,"UFLLocalFunction",Dune::Python::GenerateTypeName("UFLLocalFunctions_7f7ef99c50708814ba5a82b0956b0aed::UFLLocalFunction< typename Dune::FemPy::GridPart< Dune::Fem::FilteredGridPart< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > >, Dune::Fem::SimpleFilter< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > > >, true > > >"), Dune::Python::IncludeFiles({"python/dune/generated/localfunction_7f7ef99c50708814ba5a82b0956b0aed_a524c1196983e65de1c06d7d6afdeb44.cc"})).first;
      Dune::FemPy::registerUFLLocalFunction( module, cls );
      cls.def( pybind11::init( [] ( pybind11::object gridView, const std::string &name, int order ) {return new LocalFunctionType( Dune::FemPy::gridPart<Dune::Fem::FilteredGridPart< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > >, Dune::Fem::SimpleFilter< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > > >, true >>(gridView),name,order); } ), pybind11::keep_alive< 1, 2 >() );
      cls.def_property( "epsilon", [] ( LocalFunctionType &self ) -> UFLLocalFunctions_7f7ef99c50708814ba5a82b0956b0aed::UFLLocalFunction< typename Dune::FemPy::GridPart< Dune::Fem::FilteredGridPart< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > >, Dune::Fem::SimpleFilter< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > > >, true > > >::Conepsilon { return self.conepsilon(); }, [] ( LocalFunctionType &self, const UFLLocalFunctions_7f7ef99c50708814ba5a82b0956b0aed::UFLLocalFunction< typename Dune::FemPy::GridPart< Dune::Fem::FilteredGridPart< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > >, Dune::Fem::SimpleFilter< Dune::FemPy::GridPart< Dune::Fem::AdaptiveLeafGridPart< Dune::ALUGrid< 2, 2, Dune::simplex > > > >, true > > >::Conepsilon &v ) { self.conepsilon() = v; } );
      cls.def_property_readonly( "virtualized", [] ( LocalFunctionType& ) -> bool { return true;});
  }
}

#endif
